#include "AutoboxD.h"
#include "Control.h"
#include <qapplication.h>

#define Inherited AutoboxDData

AutoboxD::AutoboxD(QWidget* parent,const char* name):Inherited( parent, name )
{
	target=NULL;
	map=NULL;

	threshold->setMin(0);
	threshold->setMax(1.0);
	threshold2->setMin(0);
	threshold2->setMax(1.0);
	threshold3->setMin(0);
	threshold3->setMax(1.0);
	threshold4->setMin(0);
	threshold4->setMax(1.0);

	setCaption( "Autoboxer Threshold Selection" );
	connect(threshold,SIGNAL(newValue(float)),this,SLOT(newVal(float)));
	connect(threshold2,SIGNAL(newValue(float)),this,SLOT(newVal(float)));
	connect(threshold3,SIGNAL(newValue(float)),this,SLOT(newVal(float)));
	connect(threshold4,SIGNAL(newValue(float)),this,SLOT(newVal(float)));
	connect(ok,SIGNAL(clicked()),this,SLOT(Ok()));
	connect(cancel,SIGNAL(clicked()),this,SLOT(Cancel()));

}


AutoboxD::~AutoboxD()
{
if (map) delete map;
}

void AutoboxD::setup(int x,int y,float Min, float Max, EMData *Map, Control *tgt) {
min=Min;
max=Max;
map=Map;
target=tgt;
x0=x;
y0=y;

{
	threshold->setMin(min);
	threshold->setMax(max);
	threshold->setValueQ(.45);
}
//threshold->setValueQ(.7*(max-min)+min);
threshold2->setValueQ(.85);
threshold3->setValueQ(0.08);
threshold4->setValueQ(1.);
newVal(0);
}

void AutoboxD::Ok() {
hide();
target->autoBox2(val);
delete this;
}

void AutoboxD::Cancel() {
delete this;
return;
}

void AutoboxD::newVal(float X) {
if (!target || !map) return;

target->delAll();
val[0]=threshold->Value();
//val[0]=(max-min)*threshold->Value()+min;
//val[1]=2.0*(max-min)*threshold2->value()/1000.0+min;
val[1]=threshold2->Value();
val[2]=threshold3->Value();
val[3]=threshold4->Value();
//val[2]=threshold3->value()/500.0-1.0;
//val[3]=threshold4->value()/500.0-1.0;
QApplication::setOverrideCursor( waitCursor );

target->boxesFrom(map,x0,y0,0,0,val);
QApplication::restoreOverrideCursor();
}
