#include <cmath>

#ifdef _WIN32
	#include <UnixToWin.h>
#else
	#include <unistd.h>
#endif

#include <cstdio>
#include <cstring>
#include "util.h"

float fitrun(int n,float *parm,float *min,float *max, char *flag,
	float (*qual)(float *parm)) {
float *best = (float *)malloc(n*sizeof(float));
float bestv,initv,mean,v,d;
int i,j,k;

bestv=initv=qual(parm);
memcpy(best,parm,n*sizeof(float));

mean=0;
for (j=0; j<50; j++) {
	for (i=0; i<n; i++) {
		if (flag[i]) parm[i]=frand(min[i],max[i]);
	}
	v=qual(parm);
	if (v<bestv) { 
		bestv=v; 
		memcpy(best,parm,n*sizeof(float)); 
		printf("a Goodstep %f\n",v);
	}
//	else printf("a Badstep %f\n",v);
}

for (float step=.1; step>.001; step/=1.5) {
	for (j=k=0; j<20; j++,k++) {
		for (i=0; i<n; i++) {
			d=(max[i]-min[i])*step;
			if (flag[i]) parm[i]=best[i]+frand(-d,d);
		}
		v=qual(parm);
		if (v<bestv) { 
			bestv=v; 
			memcpy(best,parm,n*sizeof(float)); 
			j=0;
			printf("b Goodstep %f\n",v);
		}
//		else printf("b Badstep %f\n",v);
		if (k>100) { step*=1.5; j=k=0; }
	}
}

memcpy(parm,best,n*sizeof(float));
free(best);

printf("final %f vs %f\n",bestv,initv);
return bestv;
}
