#include <cstdio>
#include <cstdlib>

#ifdef _WIN32
	#include <UnixToWin.h>
#else
	#include <unistd.h>
#endif

#include <cmath>
#include <cctype>
#define DEBUG 0
#define JUSTFITNOISE 0
//  1 means yes

struct MicScop{		float AccVolt; float Cs;
				float Pre ;float quad ; float linear;
				float defocus ;float phi ; float Amp; float Bfactor; };



float NCurve(float s, float B, float n1, float sigma);

inline float pabs( float x){ return sqrt(x*x);}

float Residual(float *sData, float *IntData,float B, float n1, float sigma, int NumPoints, int Ismin);


void printCurve(float *sData, float *Data, int NumPoints,int Ismin, FILE* Curve);

float ResidPredVsObs(int IntCutOff,int NumPoints,float *sData, float *StructFactData,float *ResDatak,MicScop MicAllk,int type);
	
void FitNoise(int NumPoints, int Ismin, float * sData, float *IntData, float *B9, float *n19, float *sigma9, int *p1Best9);

void ctfstuff(int NumCurves, int NumPoints,MicScop* MicAll,float *sData,float *IntData,float *SFData){   

	int pDataMax; float IntDataMax;
//  %%             g = ln f = B - n1 s - sigma s^2   //
	float sigma, n1,B;
	float Error;
	float smin;
	int Ismin;
	int IFirstZero;
	int kCurve;
	FILE * ResCurve;
	FILE * NoiseCurve ;

			
	float **ResData  = (float **) calloc(NumCurves,sizeof(float *)) ; 
	float **NoiseData= (float **) calloc(NumCurves,sizeof(float *)) ; 
 


for (kCurve=0; kCurve< NumCurves; kCurve++) {
			
	ResData[kCurve]   = (float *) calloc(NumPoints,sizeof(float)) ; 
	NoiseData[kCurve] = (float *) calloc(NumPoints,sizeof(float)) ; 

} // end kCurve loop
	



for (kCurve=0; kCurve< NumCurves; kCurve++) {
	Ismin=0;
	pDataMax=-1; IntDataMax=0;


	ResCurve =fopen("ResCurve","wb");
	NoiseCurve =fopen("NoiseCurve","wb");

//         %% 0.1         Do Statistics; find pDatamax, IntDataMax
	
	smin=0; // 1./70.;
	for (int p0=1; p0 <NumPoints; p0++) {
//		if (sData[p0] >= smin  && sData[p0-1] < smin) Ismin=p0;
		if (IntData[kCurve*NumPoints +p0] > IntDataMax) { 
				IntDataMax= IntData[kCurve*NumPoints + p0];
				pDataMax  = p0 ;
//		printf("IntData[kcurve*NumPoints +p0]  = %f \n",IntData[kCurve*NumPoints +p0]);fflush(stdout); 
		}	
	}

	float IntDataSmooth=0; for (int iz=0;iz<4;iz++)  IntDataSmooth += (IntData[kCurve*NumPoints+pDataMax+1+iz])/4.;
//	%% Ismin determines the s where one should start fitting the curve to the noise
//     At this point, its value is given by  smin=.02  %%   

	float thresh = .2;
	int NumPointsCut = .9*NumPoints;
	float IntData1Over =   (IntDataSmooth )*thresh + IntData[kCurve * NumPoints +  NumPointsCut ]  * ( 1. - thresh ); //
	int pData1Over;
	float sData1Over;
	float taillogSlope = (log ((IntData[kCurve*NumPoints +NumPoints-1]) /(IntData[kCurve*NumPoints +NumPoints-4] )) )
						/( sData[NumPoints-1] - sData[NumPoints-4]);

//	if (DEBUG) printf("Section 01 Ismin  = %d , taillogSlope = %f , pDataMax= %d\n", Ismin, taillogSlope,pDataMax);fflush(stdout); 
	
	for (int j1= 1; j1 < NumPoints;j1++) {
		if (IntData[kCurve*NumPoints +j1] <= IntData1Over && IntData[kCurve*NumPoints +j1-1] >IntData1Over) {
			pData1Over= j1;
			sData1Over = sData[j1];
		}
	}
	Ismin= pData1Over ;
	printf("ctfstuff: Ismin  = %d , sData[Ismin]=%f, IntData[Ismin]=%f \n",
		Ismin,sData[Ismin], IntData[Ismin]);fflush(stdout); 
	

//      %%  1.  Now we fit the noise part:         the amplitude, exp decay, and Gaussian decay  
//       %%                  Make Two passes

	float *TempData= (float *)calloc(NumPoints,sizeof(float));
		for (int jj=0;jj<NumPoints;jj++) TempData[jj]=IntData[jj+NumPoints*kCurve];

//	Ismin=pDataMax;
	FitNoise(NumPoints, Ismin, sData, TempData, &B, &n1, &sigma, &IFirstZero);


if (1) {

	if (DEBUG) printf("kCurve = %d, B=%4.4e	sigma=%4.4e 	n1=%4.4e IFirstZero=%d, First Zero=%f Angstroms \n",
	      kCurve, B, sigma, n1,IFirstZero, 1/sData[IFirstZero]);

	for (int iD=0; iD < NumPoints; iD++) {
		NoiseData[kCurve][iD] = NCurve(sData[iD],B,n1,sigma);
		ResData[kCurve][iD] = IntData[kCurve*NumPoints +iD] - NoiseData[kCurve][iD];
//		if (iD==p1Best || iD==p2Best  || iD==p3Best )  ResData[kCurve][iD] =0 ;
	}

	printCurve(sData,  ResData[kCurve],NumPoints,0,  ResCurve);

	printCurve(sData,NoiseData[kCurve],NumPoints,0, NoiseCurve);

	if (DEBUG) printf("Finished Printing \n"); fflush(stdout);
	

//*          %% Finished fitting the noise, never need to return to noise  
//  ***      %% 2. Now find defocus and amplitude contrast. Then fit B. 
//   **      %%       Repeat. Fit defocus and amplitude contrast.


//          %%           2.1.       Fitting defocus and amp contrast 
	float s4, s5;
	float Cs = MicAll[0].Cs;  // A
	float hc = 12400; // eV-A
	float V= MicAll[0].AccVolt ; // eV
	float E0 = 511*1000; // eV
	float lambda =  hc / (sqrt(V*V + 2*E0*V));  // That's the wavelength
	float phi = 0; // should be less than 20 degrees
	float gamma, mu=0, lambda_s, lambda_s2;
	float quality, qualitymax =-1;
	float Pi=3.1415926;
	float phiBest=0, muBest=0;
	int iAMax= 700;

	
	float lambdaHat = lambda*sData[IFirstZero], lambdaHat2 = lambdaHat* lambdaHat;

	printf("Fitting Defocus                 \n");fflush(stdout);


	for (int iA=0; iA < iAMax; iA++) {
		phi = asin( .08 +.04* ((float) iA) / ((float) iAMax) );  // %% Amplitude Contrast ranges from 8 to 12% 
			mu = - Cs* lambdaHat2/2 + lambda*(phi/Pi-1)/lambdaHat2;
			if (mu<0 && mu > -8.*100000){
				quality =0;
				for (int p4= IFirstZero; p4 < NumPoints; p4++ ) {
					s4 = sData[p4]  ;
					lambda_s = lambda*s4;
					lambda_s2= lambda_s*lambda_s;
					gamma = -2*Pi*( mu*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
					quality += sin(gamma+phi)*sin(gamma+phi)* ResData[kCurve][p4];
				}
				if (quality > qualitymax) {
					qualitymax=quality;
	if (0) printf("mu =  %f micrometers entered\n", muBest/10000.);

					muBest= mu; phiBest=phi;
				}
			}  // check mu value
	}
	
	printf("mu =  %f micrometers,  amplitude contrast= %f percent \n", muBest/10000., sin(phiBest)*100);

	float ResMax=-1, sResMax;
	int IResMax;  

	
	mu=muBest; phi=phiBest;
	for (int p6=IFirstZero; p6< NumPoints; p6++) {
		if (ResData[kCurve][p6] > ResMax) { 
		ResMax = ResData[kCurve][p6]; 
		sResMax = sData[p6];
		IResMax = p6;}
	}
		
		
	float *temp2IntData = (float *) calloc(NumPoints, sizeof(float) );
	FILE * IntCurve = fopen("IntCurve","wb");
	float *WiggleData = (float *) calloc(NumPoints, sizeof(float) );
	FILE * WiggleCurve =fopen("WiggleCurve","wb");
	char printThis[1024];
	int p5;

	for ( p5=0; p5 < NumPoints; p5++) {
		s5 = sData[p5]  ;
		lambda_s = lambda*s5;
		lambda_s2= lambda_s*lambda_s;
		gamma = -2*Pi*( mu*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
		WiggleData[p5] = ResMax* sin(gamma+phi)*sin(gamma+phi);
		temp2IntData[p5] = IntData[kCurve*NumPoints +p5];
	}
//printf("did I wiggle data? \n");

//  %%    2.2        Fitting B factor; Assuming  S limits to  a constant 
//  %%            Find the  next max besides Resmax, should be in the lap 2pi to 3pi 

	float Res2Max=-1, sRes2Max;
	int IRes2Max=0;
	for (int p8=0; p8 < NumPoints; p8++) {
		s5 = sData[p8]  ;
		lambda_s = lambda*s5;
		lambda_s2= lambda_s*lambda_s;
		gamma = -2*Pi*( mu*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
		if (gamma+phi > 2.*Pi && gamma+phi < 3.*Pi) {	
			if ( ResData[kCurve][p8] > Res2Max) { 
					Res2Max  = ResData[kCurve][p8];
					sRes2Max =  sData[p8];
					IRes2Max = p8;
			}			
		}
	}
//  %%    2.2        Fitting B factor; Assuming  S limits to  a constant

//       %%    Envelope has to be of form   exp(- Bfactor (s*s -sResMax*sResMax))
	float Bfactor = (log(Res2Max/ResMax)) / (sResMax*sResMax-sRes2Max*sRes2Max);
	if (Bfactor<0) Bfactor=0;
	float AmpFactor = ResMax * exp(Bfactor*sResMax*sResMax);
	
//	printf("Bfactor =  %f ,  AmpFactor = %f percent \n", Bfactor, AmpFactor );

	for (p5=0; p5 < NumPoints; p5++) {
		s5 = sData[p5]  ;
		lambda_s       = lambda*s5;
		lambda_s2      = lambda_s*lambda_s;
		gamma          = -2*Pi*( mu*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
		WiggleData[p5] =  AmpFactor* exp(-Bfactor*s5*s5)*sin(gamma+phi)*sin(gamma+phi);
		}

	
	printCurve(sData,WiggleData,NumPoints,0,WiggleCurve);
	printCurve(sData, temp2IntData,NumPoints,0,IntCurve);
	fclose(ResCurve);
	fclose(NoiseCurve);
	fclose(WiggleCurve);
	fclose(IntCurve);
		
sprintf(printThis," xmgr   IntCurve NoiseCurve ResCurve WiggleCurve &" );	
//	if (kCurve== NumCurves-1) 

	if (DEBUG)	system(printThis); fflush(stdout);
	sleep(1);

// %%    2.3   Assemble Microscope Parameters


	MicAll[kCurve].AccVolt = V;
	MicAll[kCurve].Cs = Cs;
	MicAll[kCurve].Pre = exp(B);
	MicAll[kCurve].quad = sigma ;
	MicAll[kCurve].linear = n1;
	MicAll[kCurve].defocus =mu ;
	MicAll[kCurve].phi = (phi) ; 
	MicAll[kCurve].Amp = AmpFactor; 
	MicAll[kCurve].Bfactor = Bfactor; 

if (DEBUG) {			printf("kCurve=%d , AccVolt = %f , Cs=%f \n ",  
					kCurve , MicAll[kCurve].AccVolt, MicAll[kCurve].Cs );
			printf("Pre=%f , noise4 = %f , linear=%f \n ", 
				MicAll[kCurve].Pre,2* sqrt( MicAll[kCurve].quad)/Pi, MicAll[kCurve].linear);
			printf("defocus=%f micrometers , amp contrast = %f , Amp=%f, Bfactor=%f \n ",  
				MicAll[kCurve].defocus/10000, 100.* sin(MicAll[kCurve].phi), sqrt(MicAll[kCurve].Amp), 
								MicAll[kCurve].Bfactor/2);		
			}
} // ends if JustNoise
} // end kCurve loopp


if (1-JUSTFITNOISE) {
	
//        
//          %%            3.0    Fitting between curves 
//          %%             Create Structure Factor with the Available Data 

	float MicEffect,   SF, Norm;
	float *StructFactData = (float *) calloc(NumPoints, sizeof(float) );
	FILE * SFCurve ;
	SFCurve =fopen("SFCurve","wb");
	float s5, lambda_s, lambda_s2;
	float hc = 12400; // eV-A
	float V  = MicAll[0].AccVolt ; // eV
	float E0 = 511*1000; // eV
	float Cs = MicAll[0].Cs;  // A
	float Pi=3.1415926;
	float gamma;
	float lambda =  hc / (sqrt(V*V + 2*E0*V));  // That's the wavelength
	float epsilon = 1.e-9;
	float SFMax; int pSFMax=0;
	
	printf("start p5 loop, Cs=%4.2f um \n",Cs/10000);

//          %%      Revise SF is   < I> / <M>
	for(int iPass=0;  iPass<200; iPass++) {
		SFMax=-1;
		for (int p5=pSFMax; p5 < NumPoints; p5++) {
//		printf("p5 = %d \n" ,p5);fflush(stdout);
			s5 = sData[p5]  ;
			lambda_s = lambda*s5;
			lambda_s2= lambda_s*lambda_s;
			MicEffect =0;
			SF=0; Norm =0;
			for (kCurve=0;kCurve< NumCurves; kCurve++) {
		
				gamma = -2*Pi*( MicAll[kCurve].defocus*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
				MicEffect =  MicAll[kCurve].Amp* exp(-MicAll[kCurve].Bfactor*s5*s5);  // %% Notice the 2 !!! OOPS 
				MicEffect *= sin(gamma+MicAll[kCurve].phi)*sin(gamma+MicAll[kCurve].phi);
				MicEffect += epsilon;
				SF        += MicEffect* ResData[kCurve][p5];
				Norm      += MicEffect*MicEffect;
//			printf("MicEffect = %4.4e epsilon = %4.4e, gamma=%4.4e \n" ,MicEffect,epsilon,gamma);fflush(stdout);
			}
//		printf("finished kcurve loop, Cs=%f \n",Cs);
			if (SF>0) StructFactData[p5] = SF/Norm;
			if (SF/Norm > SFMax &&  p5 < NumPoints/2) { SFMax= SF/Norm; pSFMax= p5;}
//		printf("StructFactData=%f\n ",  StructFactData[p5] );	fflush(stdout);
	}
	
//          %%        4.       	 Do   A Pass on Each Amplitude and Bfactor. Then Recompute Structure Factor.
//          %%      Revise Amplitude is   < I> / <M S>
//
//               %%  Correct Amplitude 
		float Atemp, AmpBest, ErrorMin;
//	
		for (kCurve=0; kCurve < NumCurves; kCurve++) {
		if (iPass==0){
				MicEffect =0;
			Atemp=0; Norm =0;
			for (int p5=pSFMax; p5 < NumPoints; p5++) {
				s5= sData[p5] ;
				if (s5 <.3 && p5> pSFMax) {    //       %% if  close to the origin and p5  past the max      
					gamma = -2*Pi*( MicAll[kCurve].defocus*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
					MicEffect =  MicAll[kCurve].Amp* exp(-MicAll[kCurve].Bfactor*s5*s5);
					MicEffect *= sin(gamma+MicAll[kCurve].phi)*sin(gamma+MicAll[kCurve].phi);
					MicEffect += epsilon;
					Atemp       += MicEffect* ResData[kCurve][p5]*StructFactData[p5];
					Norm      += MicEffect*MicEffect*StructFactData[p5]*StructFactData[p5];
				}
			}
	if (DEBUG)	printf("kCurve=%d , Aold = %f , Anew=%f, Norm=%f, iPass=%d, pSFMax=%d \n",
				kCurve, MicAll[kCurve].Amp, Atemp/Norm, Norm, iPass, pSFMax);
			Atemp = Norm* sqrt(Atemp/Norm*  MicAll[kCurve].Amp);
			MicAll[kCurve].Amp = sqrt(Atemp/Norm*  MicAll[kCurve].Amp);
		} else { 
			if (kCurve >0) {	
				ErrorMin=-1;
				Atemp =		MicAll[kCurve].Amp;

				for (int iAmp=0; iAmp <100; iAmp++) {
					MicAll[kCurve].Amp = Atemp*(100. + (iAmp-50)*.2)/ 100.;
					Error =  ResidPredVsObs(pSFMax,NumPoints,sData,StructFactData,ResData[kCurve],MicAll[kCurve],0);
					if (ErrorMin<0 || Error < ErrorMin){
						ErrorMin= Error;
						AmpBest = MicAll[kCurve].Amp ;
					}
				}
				MicAll[kCurve].Amp = AmpBest;
//				printf("kCurve=%d , Aold = %f , Anew=%f, Norm=%f, iPass=%d, Error=%f \n",
//					kCurve, MicAll[kCurve].Amp, Atemp/Norm, Norm, iPass, Error);
			}
		}


		} // end kcurve for updating amplitudes
//               %%  Correct Bfactor with ln correction

		float BfactorTemp, BfactorBest;

		for (kCurve=1; kCurve < NumCurves; kCurve++) {
			ErrorMin=-1;
			BfactorTemp =		MicAll[kCurve].Bfactor;

			for (int iB=0; iB <100; iB++) {
				MicAll[kCurve].Bfactor = BfactorTemp*(100. + (iB-50)*.2)/ 100.;
				Error =  ResidPredVsObs(pSFMax,NumPoints,sData,StructFactData,ResData[kCurve],MicAll[kCurve],0);
				if (ErrorMin<0 || Error < ErrorMin){
					ErrorMin= Error;
					BfactorBest = MicAll[kCurve].Bfactor ;
				}
			}
			MicAll[kCurve].Bfactor = BfactorBest;
			if (DEBUG) printf("kCurve=%d , Aold = %f , Anew=%f, Norm=%f, iPass=%d, Error=%f \n",
				kCurve, MicAll[kCurve].Amp, Atemp/Norm, Norm, iPass, Error);
		}
				
		

//               %%  Correct defocus with ln correction, after first zero
	
//               %%  Correct amplitude contrast with ln correction after first zero
	
//          %%    Reproject At End

	} // end iPass

	printCurve(sData,StructFactData,NumPoints,0,SFCurve);
	fclose(SFCurve);
	if (DEBUG)	system("xmgr SFCurve &");


	FILE * tempIntCurve;
	float *tempIntData = (float *) calloc(NumPoints, sizeof(float) );
	
	for (kCurve=0; kCurve < NumCurves; kCurve++) {
		printf("entered last loop \n"); fflush(stdout);
		tempIntCurve  =fopen("tempIntCurve","wb");
		ResCurve      =fopen("ResCurve","wb");

		for (int p5=0; p5 < NumPoints; p5++) {
//		printf("p5 = %d \n" ,p5);fflush(stdout);
			s5 = sData[p5]  ;
			lambda_s = lambda *s5;
			lambda_s2= lambda_s*lambda_s;
			MicEffect =0;
			SF=0; Norm =0;
			gamma = -2*Pi*( MicAll[kCurve].defocus*lambda_s2/2 + Cs* lambda_s2*lambda_s2/4)/ lambda;
			MicEffect =  MicAll[kCurve].Amp* exp(-MicAll[kCurve].Bfactor*s5*s5);
			MicEffect *= sin(gamma+MicAll[kCurve].phi) * sin(gamma+MicAll[kCurve].phi);
//			printf("MicEffect=%f \n",MicEffect);
		
			tempIntData[p5] = MicEffect*StructFactData[p5];
		}
		
		printCurve(sData,ResData[kCurve],NumPoints,0,ResCurve);
		printCurve(sData,tempIntData,NumPoints,0,tempIntCurve);
	
		fclose(tempIntCurve);
		fclose(ResCurve);
		sleep(1);	
//		if (DEBUG)	system("xmgr ResCurve tempIntCurve  &");
	} //  %% ends kCurve loop for calculating the SF
	
//		system("killall xmgr &");
	 	
//            %%          3.1       Fitting Amplitudes to Minimize  
//               %%             ResidPredVsObs(IntCutOff,NumPoints,StructFactData,ResData[kCurve],MicAll[kCurve])     


} // ends if loop
	system("/bin/rm IntCurve NoiseCurve WiggleCurve ResCurve SFCurve tempIntCurve");
}
