#include "InspHist.h"
#include <qfile.h>
#include <cstdlib>
#include "util.h"
#define Inherited InspHistData

InspHist::InspHist(QWidget* parent,const char* name):Inherited( parent, name ) {

histlist.setAutoDelete(TRUE);
}


InspHist::~InspHist() {
}

void InspHist::setHist (EMHist *hist) {
QString s(hist->getDir());
int i,f=0;
s+="/.emanlog";
QFile in(s);
char t[1024];
EMHist *hi;

//printf("%s\n",s.data());

in.open(IO_ReadOnly);
histlist.clear();
while (in.readLine(t,1023)>0) {
	i=atoi(t);
	if (i!=hist->id) continue;
	hi=new EMHist(t);
	histlist.append(hi);
}
in.close();

QCString com("History - ");
QCString inf("Input: ");
QCString outf("Output: ");
QCString reff("Ref: ");
QCString msc("Comment: ");
QCString tm("Start: ");

for (EMHist *h=histlist.first(); h; h=histlist.next()) {
	if (h->type==LOG_BEGIN) { 
		command->setText(h->info); 
		com+=h->command;
		tm+=h->tstr;
		tm+="   ";
		i=h->etime;
	}
	if (h->type==LOG_INFILE) { inf+=h->file; inf+=" "; }
	if (h->type==LOG_OUTFILE) { outf+=h->file; outf+=" "; }
	if (h->type==LOG_REFFILE) { reff+=h->file; reff+=" "; }
	if (h->type==LOG_END) {
		msc+=h->info;
		msc.stripWhiteSpace();
		QCString s2;
		i=h->etime-i;
		s2.sprintf("Run Time: %d:%02d:%02d",i/3600,(i%3600)/60,i%60);
		tm+=s2;
		f=1;
	}
}
if (!f) tm+="Not Finished";

dtime->setText(tm);
title->setText(com);
ifile->setText(inf);
ofile->setText(outf);
rfile->setText(reff);
misc->setText(msc);
}
