#include "Start.h"
#include <qmessagebox.h>

#define Inherited StartData

Start::Start(QWidget* parent,const char* name):Inherited( parent, name )
{
	setCaption( "EMAN" );
	form1=form2=form3=form4=NULL;
	qtb=new QTextBrowser2;
	qtb->resize(600,350);
}


Start::~Start()
{
delete qtb;
}

void Start::step1() {
QCString file(1024);
FEntry *fe;
int mem=0;

if (form1) { form1->show(); return; }
form1=new Form();

file.sprintf("%s/doc/form/step1.form",EMDIR());

printf("form '%s'\n",file.data());
form1->parseFile(file.data());

fe=form1->getItem("user");
fe->setIntValue(0);

fe=form1->getItem("voltage");
fe->setIntValue(400);

fe=form1->getItem("csubs");
fe->setIntValue(4.1);

fe=form1->getItem("mag");
fe->setIntValue(50);

fe=form1->getItem("scan");
fe->setIntValue(14);

fe=form1->getItem("scandpi");
fe->setIntValue(1814.3);

fe=form1->getItem("apix");
fe->setFloatValue(2.8);

fe=form1->getItem("psize");
fe->setFloatValue(250.0);

fe=form1->getItem("proc");
fe->setFloatValue(1);

fe=form1->getItem("res");
fe->setFloatValue(25.0);

fe=form1->getItem("image");
fe->setFloatValue(3000.0);

fe=form1->getItem("speed");
fe->setIntValue(0);

form1->readValFromFile(".form1");

// This will try to figure out how much memory the computer has
fe=form1->getItem("memory");
if (!access("/proc/meminfo",R_OK)) {
	QFile in("/proc/meminfo");
	char s[256];
	in.open(IO_ReadOnly);
	while (in.readLine(s,255)>0) {
		if (!strncmp(s,"MemTotal",8)) { sscanf(s+10," %d",&mem); mem/=1000; break; }
	}
	fe->setIntValue(mem);
}
else if (!access("/bin/hinv",R_OK)) {
	FILE *in;
	char s[256];
	in=popen("/bin/hinv","r");
	while(fgets(s,255,in)) {
		if (!strncmp(s,"Main memory",11)) { sscanf(s+17," %d",&mem); break; }
	}
}

form1->show();

connect(form1,SIGNAL(changed(const char *)),this,SLOT(step1e(const char *)));
}

void Start::step2() {
QCString file(1024);
FEntry *fe;

if (form2) { form2->show(); return; }
form2=new Form();

file.sprintf("%s/doc/form/step2.form",EMDIR());

form2->parseFile(file.data());

fe=form2->getItem("sym");
fe->setStringValue("C1");

form2->readValFromFile(".form2");

form2->show();

connect(form2,SIGNAL(changed(const char *)),this,SLOT(step2e(const char *)));

}

void Start::step3() {
QCString file(1024);
FEntry *fe;

if (form3) { form3->show(); return; }
form3=new Form();

file.sprintf("%s/doc/form/step3.form",EMDIR());

form3->parseFile(file.data());

fe=form3->getItem("res");
fe->setIntValue(18);

form3->readValFromFile(".form3");

form3->show();

connect(form3,SIGNAL(changed(const char *)),this,SLOT(step3e(const char *)));

}

void Start::step4() {
QCString file(1024);
FEntry *fe;

if (form4) { form4->show(); return; }
form4=new Form();

file.sprintf("%s/doc/form/step4.form",EMDIR());

form4->parseFile(file.data());

//form4->readValFromFile(".form4");

form4->show();

connect(form4,SIGNAL(changed(const char *)),this,SLOT(step4e(const char *)));

}

void Start::step1e(const char *label) {
FEntry *fe;
float voltage,csubs,mag,apix,scan,scandpi,res;
int user,psize,bsize,ctf,memory,proc,speed,imagesz;

form1->setBusy(1);

if (!strcmp(label,"user")) {

}
else if (!strcmp(label,"memory")) {

}
else if (!strcmp(label,"psize")) {
	fe=form1->getItem("apix");
	apix=fe->floatValue();
	fe=form1->getItem("psize");
	psize=fe->floatValue();
	fe=form1->getItem("bsize");
	fe->setIntValue(((int)floor(1.3*psize/apix))&0xfff8);
}
else if (!strcmp(label,"bsize")) {

}
else if (!strcmp(label,"voltage")) {

}
else if (!strcmp(label,"csubs")) {

}
else if (!strcmp(label,"mag") || !strcmp(label,"scan") || 
		!strcmp(label,"scandpi") || !strcmp(label,"apix")) {
	fe=form1->getItem("scan");
	scan=fe->floatValue();
	fe=form1->getItem("scandpi");
	scandpi=fe->floatValue();
	fe=form1->getItem("mag");
	mag=fe->floatValue();
	fe=form1->getItem("apix");
	apix=fe->floatValue();

	if (mag==0) mag=1.0;
	if (scan==0) scan=1.0;
	
	if (!strcmp(label,"mag")) {
		fe=form1->getItem("apix");
		fe->setFloatValue(10.0*scan/mag);
	}
	else if (!strcmp(label,"scan")) {
		fe=form1->getItem("apix");
		fe->setFloatValue(10.0*scan/mag);
		fe=form1->getItem("scandpi");
		fe->setFloatValue(25400.0/scan);
	}
	else if (!strcmp(label,"scandpi")) {
		fe=form1->getItem("scan");
		fe->setFloatValue(scan=25400.0/scandpi);	
		fe=form1->getItem("apix");
		fe->setFloatValue(10.0*scan/mag);
	}
	else if (!strcmp(label,"apix")) {
		fe=form1->getItem("mag");
		fe->setFloatValue(10.0*scan/apix);	
	}

}

else if (!strcmp(label,"DONE")) {
	// get all the values so we can generate instructions
	voltage=form1->getItem("voltage")->floatValue();
	csubs=form1->getItem("csubs")->floatValue();
	mag=form1->getItem("mag")->floatValue();
	apix=form1->getItem("apix")->floatValue();
	res=form1->getItem("res")->floatValue();
	user=form1->getItem("user")->intValue();
	psize=form1->getItem("psize")->intValue();
	bsize=form1->getItem("bsize")->intValue();
	ctf=form1->getItem("ctf")->intValue();
	memory=form1->getItem("memory")->intValue()-24;	//24 meg overhead
	proc=form1->getItem("proc")->intValue();
	speed=form1->getItem("speed")->intValue();
	imagesz=form1->getItem("image")->intValue();

	// Store the values in a file for later use
	form1->dumpValToFile(".form1");
	delete form1;
	form1=NULL;
	
	//Now generate a set of instructions (and open them)
	FILE *out;
	char *dir = (char *)malloc(strlen(EMDIR())+26);
	strcpy(dir,EMDIR());
	strcat(dir,"/doc/form/step1txt.html");
	
	out=fopen("step1.html","wb");
	if (!out) { printf("Cannot write instruction file!\n"); return; }
	addHTMLSection(dir,out,"0");
	addHTMLSection(dir,out,"1");

	if (!bsize) {
		fprintf(out,"<p>You didn't specify a particle box size. This is required for most of the memory \
 evaluation. When you decide what box size to use in step 1, press the step 1 button again and fill \
 this value in.\n");
	}
	if (memory && bsize) {
		int max;
		fprintf(out,"<p>Different parts of the reconstruction naturally have different\n\
memory requirements. This is an approximation of the memory that will be used in the different\n\
phases of the reconstruction procedure. Note these are rough approximations only!<br><ul>\n");
		fprintf(out,"<li>boxer - %d megs\n",imagesz*imagesz*6/1000000);
		if (imagesz*imagesz*6/1000000>memory) fprintf(out,"(since this is more memory than you have, either box your\
 particles on a machine with more memory, or try using the fractional reading option in \
 <a href=%s/doc/progs/boxer.html>boxer</a>.\n",EMDIR());
 		int ptcl=memory*1000000/(bsize*bsize*4*3);
		fprintf(out,"<li>cenalignint - you have enough memory to process %d particles at a time\n",ptcl-(ptcl%100));
		fprintf(out,"<li>classesbymra - you have enough memory for %d projections \
(this depends on the ang= and sym= parameter)\n",ptcl*3/4-((ptcl*3/4)%100)); // last 4 is a guess
		fprintf(out,"<li>classalignall - you should have no more than %d particles in a single class \
(this depends on the number of particles, number of projections, and how evenly \
distributed your particle orientations are)\n",ptcl-(ptcl%100));
		fprintf(out,"<li>make3d - The 3D models used in reconstruction require %d megs, meaning there shoudld \
be no more than ~%d class averages.\n",bsize*bsize*bsize*4*5/1000000,(memory*1000000-bsize*bsize*bsize*4*5)/(bsize*bsize*4*2));
		fprintf(out,"</ul><br><br>\n");
	}
	if (res/2.8<apix) fprintf(out,"<p><b>Warning:</b>The absolute maximum resolution you could achieve with this A/pixel\
 setting is %1.0f A, but it is suggested that you have at least 3x oversampling, meaning your data should\
 be %1.2f A/pix or less for your specified resolution goal.\n",apix*2.0,res/3.0);
 	if (apix*4.0<res) fprintf(out,"<p>Generally 3x oversampling is suggested, so, with a target resolution of\
 %1.0f, the optimal A/pix would be %1.1f. If your final resolution goal is somewhere around %1.0fA, and\
 you are simply starting with a low resolution, this is fine. Otherwise you should consider rescaling the\
 data closer to the optimal sampling. This can make a dramatic improvement in reconstruction speed, and in\
 some cases will even improve the final model. The boxed out particles can be reduced in size with proc2d and the shrink option if desired.\n",res,res/3.0,apix*3.0);


	if (ctf) {
		addHTMLSection(dir,out,"2");
		if (!user) addHTMLSection(dir,out,"2.1");
		addHTMLSection(dir,out,"3n");
		if (!user) addHTMLSection(dir,out,"3.1n");
		addHTMLSection(dir,out,"4");
		if (!user) addHTMLSection(dir,out,"4.1n");
		addHTMLSection(dir,out,"5n");
		if (!user) addHTMLSection(dir,out,"5.1n");
		addHTMLSection(dir,out,"6");
		if (!user) addHTMLSection(dir,out,"6.1");
		addHTMLSection(dir,out,"7");
	}
	else {
		addHTMLSection(dir,out,"2");
		if (!user) addHTMLSection(dir,out,"2.1");
		addHTMLSection(dir,out,"3c");
		if (!user) addHTMLSection(dir,out,"3.1c");
		addHTMLSection(dir,out,"4");
		if (!user) addHTMLSection(dir,out,"4.1c");
		addHTMLSection(dir,out,"5c");
		if (!user) addHTMLSection(dir,out,"5.1c");
		addHTMLSection(dir,out,"6");
		if (!user) addHTMLSection(dir,out,"6.1");
		addHTMLSection(dir,out,"7");
	}
	fclose(out);

	QString st=getenv("PWD");
	st+="/step1.html";
	qtb->show();
	qtb->setLSource("/dev/null");
	qtb->update();
	qtb->setLSource(st);
	qtb->update();
//	qtb->resize(qtb->width(),qtb->height());

/*	QCString st="netscape -remote 'openfile(";
	st+=getenv("PWD");
	st+="/step1.html,new-window)'";
	printf("%s\n",st.data());
	if (system(st.data())) {
		QMessageBox::warning ( NULL, "Run Netscape", "The EMAN Reconstruction tutorial uses Netscape.\nPlease start netscape running, then click DONE on the form again.", 1,0,0 );
	}*/
	
//	if (!user)
//		QMessageBox::warning ( NULL, "Run Netscape", "EMAN Reconstruction Guidance uses Netscape. Please start netscape running, then click DONE again.", 1,0,0 );

	delete form1;
	form1=NULL;

	return;
}

form1->setBusy(0);
}

void Start::step3e(const char *label) {

if (!strcmp(label,"DONE")) {
	QCString *sym,*str;
	int user,proc,ctfc,bsize;
	float res,psize,apix;

	str=Form::valFromFile(".form1","user");
	if (!str) {
		QMessageBox::warning( NULL, "Step 1 first", "You must go through the step 1 form (in this directory)\nbefore proceeding to step 2.", 1,0,0 );
		return;
	}
	user=str->toInt();
	delete str;

	sym=Form::valFromFile(".form2","sym");
	if (!sym) {
		QMessageBox::warning( NULL, "Step 2 first", "You must go through the step 1 form (in this directory)\nbefore proceeding to step 2.", 1,0,0 );
		return;
	}

	str=Form::valFromFile(".form1","proc");
	proc=str->toInt();
	delete str;

	str=Form::valFromFile(".form1","apix");
	apix=str->toFloat();
	delete str;

	str=Form::valFromFile(".form1","psize");
	psize=str->toFloat();
	delete str;

	str=Form::valFromFile(".form1","ctf");
	if (!str) printf("Error reading .form1\n");
	
	if (*str[0]=='1') { 
		ctfc=0;
//		printf("no ctfc '%c'\n",*str[0]);
	}
	else {
		ctfc=1;
//		printf("ctfc '%c'\n",*str[0]);
	}
	delete str;

	res=form3->getItem("res")->floatValue();
	bsize=form3->getItem("bsize")->intValue();
	if (bsize<=4) {
		str=Form::valFromFile(".form1","bsize");
		bsize=str->toFloat();
		delete str;
	}

	// Store the values in a file for later use
	form3->dumpValToFile(".form3");
//	delete form3;
//	form2=NULL;
	
	//Now generate a set of instructions (and open them)
	FILE *out;
	char *dir = (char *)malloc(strlen(EMDIR())+26);
	strcpy(dir,EMDIR());
	strcat(dir,"/doc/form/step3txt.html");
	
	out=fopen("step3.html","wb");
	if (!out) { printf("Cannot write instruction file!\n"); return; }
	addHTMLSection(dir,out,"0");

	if (!user) {
		if (!ctfc) addHTMLSection(dir,out,"1n");
		else addHTMLSection(dir,out,"1c");
	}

	float angi=.75*atan(2.0*res/psize)*180.0/PI;
	if (angi>9.0) angi=9.0;
	if (bsize>4) {
		fprintf(out,"<pre>refine 8 ang=%1.1f mask=%d pad=%d hard=25 classkeep=.8 classiter=8 sym=%s ",
			angi,2+(int)floor(psize/(2.0*apix)),(bsize*3/2)&0xfff8,sym->data());
		if (ctfc) fprintf(out,"ctfc=%1.1f ",res);
		if (proc>1) fprintf(out,"proc=%d ",proc);
		//if (angi<5) fprintf(out,"tree=3 ");
		//else if (angi<9) fprintf(out,"tree=2 ");
		fprintf(out,"</pre>\n");
	}
	else fprintf(out,"<h2>You didn't specify a particle box size. Please go back to the form and specify this.</h2>");

	if (!user) addHTMLSection(dir,out,"2");
	addHTMLSection(dir,out,"3");
	
	fclose(out);

	QString st=getenv("PWD");
	st+="/step3.html";
	qtb->show();
	qtb->setLSource("/dev/null");
	qtb->update();
	qtb->setLSource(st);
	qtb->update();
	qtb->resize(qtb->width(),qtb->height());

/*	QCString st="netscape -remote 'openfile(";
	st+=getenv("PWD");
	st+="/step3.html,new-window)'";
	printf("%s\n",st.data());
	if (system(st.data())) {
		QMessageBox::warning ( NULL, "Run Netscape", "The EMAN Reconstruction tutorial uses Netscape.\nPlease start netscape running, then click DONE on the form again.", 1,0,0 );
	}*/
	
	delete form3;
	form3=NULL;

	return;
}

}

void Start::step2e(const char *label) {

if (!strcmp(label,"DONE")) {
	QCString sym,*str;
	int user;

	str=Form::valFromFile(".form1","user");
	if (!str) {
		QMessageBox::warning( NULL, "Step 1 first", "You must go through the step 1 form (in this directory)\nbefore proceeding to step 2.", 1,0,0 );
		return;
	}
	user=str->toInt();
	delete str;

	sym=form2->getItem("sym")->strValue();
	sym=sym.lower();

	// Store the values in a file for later use
	form2->dumpValToFile(".form2");
	delete form2;
	form2=NULL;
	
	//Now generate a set of instructions (and open them)
	FILE *out;
	char *dir = (char *)malloc(strlen(EMDIR())+26);
	strcpy(dir,EMDIR());
	strcat(dir,"/doc/form/step2txt.html");
	
	out=fopen("step2.html","wb");
	if (!out) { printf("Cannot write instruction file!\n"); return; }
	addHTMLSection(dir,out,"0");

	if (sym.left(4)=="icos") {
		addHTMLSection(dir,out,"icos");
		if (!user) addHTMLSection(dir,out,"icos.1");
	}
	else if (sym.left(1)=="c") {
		if (sym.mid(1,3).toInt()<3) {
			addHTMLSection(dir,out,"asym");
			if (!user) addHTMLSection(dir,out,"asym.1");
		}
		else {
			addHTMLSection(dir,out,"csym");
			if (!user) addHTMLSection(dir,out,"csym.1");
		}
	}
	else if (sym.left(1)=="d") {
		if (sym.mid(1,3).toInt()<3) {
			addHTMLSection(dir,out,"asym");
			if (!user) addHTMLSection(dir,out,"asym.1");
		}
		else {
			addHTMLSection(dir,out,"dsym");
			if (!user) addHTMLSection(dir,out,"dsym.1");
		}
	}
	else {
		addHTMLSection(dir,out,"unk");
		if (!user) addHTMLSection(dir,out,"unk.1");
	}

	addHTMLSection(dir,out,"2");

	fclose(out);

	QString st=getenv("PWD");
	st+="/step2.html";
	qtb->show();
	qtb->setLSource("");
	qtb->update();
	qtb->setLSource(st);
	qtb->update();
	qtb->resize(qtb->width(),qtb->height());

/*	QCString st="netscape -remote 'openfile(";
	st+=getenv("PWD");
	st+="/step2.html,new-window)'";
	printf("%s\n",st.data());
	if (system(st.data())) {
		QMessageBox::warning ( NULL, "Run Netscape", "The EMAN Reconstruction tutorial uses Netscape.\nPlease start netscape running, then click DONE on the form again.", 1,0,0 );
	}*/
	
//	if (!user)
//		QMessageBox::warning ( NULL, "Run Netscape", "EMAN Reconstruction Guidance uses Netscape. Please start netscape running, then click DONE again.", 1,0,0 );

	delete form2;
	form2=NULL;

	return;
}

}

void Start::step4e(const char *label) {
if (!strcmp(label,"Ready")) {
	//Now generate a set of instructions (and open them)
	FILE *out;
	char *dir = (char *)malloc(strlen(EMDIR())+26);
	strcpy(dir,EMDIR());
	strcat(dir,"/doc/form/step4txt.html");
	
	out=fopen("step4.html","wb");
	if (!out) { printf("Cannot write instruction file!\n"); return; }
	addHTMLSection(dir,out,"0");

	fclose(out);

	QString st=getenv("PWD");
	st+="/step4.html";
	qtb->show();
	qtb->setLSource("");
	qtb->update();
	qtb->setLSource(st);
	qtb->update();
	qtb->resize(qtb->width(),qtb->height());

/*	QCString st="netscape -remote 'openfile(";
	st+=getenv("PWD");
	st+="/step4.html,new-window)'";
	printf("%s\n",st.data());
	if (system(st.data())) {
		QMessageBox::warning ( NULL, "Run Netscape", "The EMAN Reconstruction tutorial uses Netscape.\nPlease start netscape running, then click DONE on the form again.", 1,0,0 );
	}*/
	
	delete form4;
	form4=NULL;

	return;

}
}

void Start::browser(){

if (control) { control->show(); return; }
control=new Control(NULL,"Name");
//a.setMainWidget(control);
control->show();
initdone=1;
//return a.exec();
}

void Start::help() {
/*char s[1024];

sprintf(s,"netscape -remote 'openFile(%s/doc/index.html,new-window)'",EMDIR());
if (system(s)) {
	QMessageBox::warning ( NULL, "Run Netscape", "The EMAN help system uses Netscape. Please start netscape running, then click HELP again.", 1,0,0 );
	return;
}*/

	QString st=EMDIR();
	st+="/doc/toc2.html";
	qtb->show();
	qtb->setLSource("");
	qtb->update();
	qtb->setLSource(st);
	qtb->update();
	qtb->resize(qtb->width(),qtb->height());

}

void Start::quit() {
close(TRUE);
}
