#include <cstdio>
#include "EMData.h"
#include "Image.h"
#include "qutil.h"
#include "TriView.h"

#ifdef UBUNTU
	#include <qapplication.h>
#else	//UBUNTU
	#include <qapp.h>
#endif	//UBUNTU

int initdone=0;

int main( int argc, char **argv )
{
QFont *newdf;
QApplication a( argc, argv );
TriView **tri = (TriView **)malloc((sizeof(TriView*))*10);
int i;

//appinit(argc,argv);
if (argc<2) appusage(argv[0]);

EMQInit(&a);

tri[0]=new TriView;
tri[0]->connect(tri[0],SIGNAL(select(float,float,int,float,int)),tri[0],SLOT(captionDisplay(float,float,int,float,int)));
tri[0]->connect(tri[0],SIGNAL(select(float,float,int,float,int)),tri[0],SLOT(imageDisplay(float,float,int,float,int)));
a.setMainWidget(tri[0]);
tri[0]->resize(300,300);
tri[0]->show();
tri[0]->clear();
int ntri=0;

int fc;
if ((fc=fileCount(argv[1]))>1) {		// an image file
	EMData d;
	int v1,v2;
	d.readImage(argv[1],0,0);
	v1=d.NImg();
	d.readImage(argv[1],1,0);
	v2=d.NImg();

	if (v1<0 && v2>0) {					// assume it's a 'classes' file
		for (int i=1; i<fc; i+=2) {
			d.readImage(argv[1],i,1);
			tri[ntri]->addPoint(d.az(),d.alt(),d.NImg(),i);
		}
		tri[ntri]->setDispFsp(QString(argv[1]));
	}
	else {								// generic particle data with eulers
		for (int i=0; i<fc; i++) {
			d.readImage(argv[1],i,1);
			tri[ntri]->addPoint(d.az(),d.alt(),d.NImg()==0?1.0:d.NImg(),i);
		}
		tri[ntri]->setDispFsp(QString(argv[1]));
	}
}
else {		//text file hopefully
	char s[256];
	FILE *in;
	if (argv[1][0]=='-') in=stdin;
	else in=fopen(argv[1],"rb");

	while (fgets(s,250,in)) {
		if (s[0]=='#') continue;
		if (s[0]=='!') {
			ntri++;
			tri[ntri]=new TriView;
			tri[ntri]->connect(tri[ntri],SIGNAL(select(float,float,int,float,int)),tri[ntri],SLOT(captionDisplay(float,float,int,float,int)));
			tri[ntri]->connect(tri[ntri],SIGNAL(select(float,float,int,float,int)),tri[ntri],SLOT(imageDisplay(float,float,int,float,int)));
			tri[ntri]->resize(300,300);
			tri[ntri]->show();
			tri[ntri]->clear();
		}
		if (s[0]=='c') {
			tri[ntri]->update();
			a.processEvents(500);
			tri[ntri]->clear();
			continue;
		}
		float alt,az,v;
		int n=sscanf(s," %f %f %f",&alt,&az,&v);
		if (n==3) tri[ntri]->addPoint(az,alt,v);
		else if (n==2) tri[ntri]->addPoint(az,alt,1.0);
	}
	if (in!=stdin) fclose(in);
}

return a.exec();

}
