#!/usr/bin/env python

import EMAN
import sys
import os.path

def printEM(e):
    print "\tmin =", e.Min()
    print "\tmax =", e.Max()
    print "\tmean =", e.Mean()
    print "\tnx =", e.xSize()
    print "\tny =", e.ySize()
    print "\tnz =", e.zSize()


images = ["tablet.mrc", "search.dm3", "t1.hdf", "micam.img", "test2.tif"]

for image1 in images:
    imagefile = os.environ['HOME'] + "/images/" + image1
    print "read image: " + imagefile
    
    e = EMAN.EMData()
    err = e.readImage(imagefile)
    if err:
        print "Error in readImage " + imagefile
        sys.exit(1)
    
    printEM(e)

    tmpfile = "test.mrc"
    
    err = e.writeImage(tmpfile)
    if err:
        print "Error in writeImage " + imagefile + " to " + tmpfile
        sys.exit(1)

    else:
        os.unlink(tmpfile)
        

