#include <qapplication.h>
#include "control.h"
#include "qutil.h"

int main( int argc, char ** argv )
{
	char* boxfile=NULL, *scale=NULL, *width=NULL;
    QApplication a( argc, argv );
    EMQInit(&a);
    Control *w = new Control;
    a.setMainWidget(w);
    w->show();
    if (argc>=1) w->setData(argv[1]);
    for (int i=2; i<argc; i++) {	
	if (strncmp(argv[i],"box=",4)==0) boxfile=&argv[i][4];
	else if (strncmp(argv[i],"scale=",6)==0) scale=&argv[i][6];
	else if (strncmp(argv[i],"width=",6)==0) width=&argv[i][6];
	else { printf("Unknown argument '%s'\n",argv[i]); exit(1); }
	}
	if(scale) w->setScale(scale);
	if(boxfile) w->fileReadDB(boxfile);
	if(width) w->boxwidth->setValue(atoi(width));
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    a.connect( w,SIGNAL(exit()), &a, SLOT( quit() ));
    a.connect(&a,SIGNAL(aboutToQuit()),w,SLOT(bye()));
    return a.exec();
    
}
