/**
 * $Id: byteorder.C,v 1.4 2006/08/15 20:19:27 gtang Exp $
 */
#include "byteorder.h"
#include "util.h"

bool ByteOrder::is_machine_endian_checked = false;
bool ByteOrder::machine_big_endian = false;

bool ByteOrder::is_machine_big_endian()
{
    if (!is_machine_endian_checked) {
	int one = 1;
	char* p_one = (char*) (&one);
	
	if(p_one[0] == 1 && p_one[1] == 0 && p_one[2] == 0 && p_one[3] == 0) {
	    machine_big_endian = false;
	}
	else {
	    machine_big_endian = true;
	}

	is_machine_endian_checked = true;
    }

    return machine_big_endian;
}

bool ByteOrder::is_float_big_endian(float f)
{
	bool is_big = false;
	
	if (goodf(&f) && f > 0 && f < 65535.0 && f == floor(f)) {
		is_big = is_machine_big_endian();
	}
	else {
		is_big = !is_machine_big_endian();
	}

	return is_big;
}
