#include "PyEMDataWrap.h"
#include "PyEMData.h"
#include "PyEuler.h"
#include "PyVect.h"
#include "PyPickle.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>

namespace python = boost::python;

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setTAlign, setTAlign, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setRAlign, setRAlign, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_zero, zero, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RFAlign, py_RFAlign, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlign, py_RTFAlign, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignBest, py_RTFAlignBest, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_refineAlign, refineAlign, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignRadon, py_RTFAlignRadon, 1, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTAlignRadon, py_RTAlignRadon, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlow, py_RTFAlignSlow, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlowest, py_RTFAlignSlowest, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_makeRFP, py_makeRFP, 0, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_unwrap, py_unwrap, 0, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_littleBigDot, py_littleBigDot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotAlignCH, rotAlignCH, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign3d, transAlign3d, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCF, py_calcCCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcFLCF, py_calcFLCF, 2, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCFX, py_calcCCFX, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcMCF, py_calcMCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign, transAlign3d, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslate, rotateAndTranslate, 0, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslateFast, rotateAndTranslateFast, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_fastTranslate, fastTranslate, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cmCenter, cmCenter, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyMask, applyMask, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_autoMask, autoMask, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyRadFn, py_applyRadFn, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_normalizeTo, py_normalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_edgeNormalize, edgeNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_xNormalize, xNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_leastSquareNormalizeTo, py_leastSquareNormalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_maskNormalize, maskNormalize, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dotRT, dotRT, 4, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dot, dot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_lcmp, py_lcmp, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_realFilter, realFilter, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverage, py_makeAverage, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCWauto, py_makeAverageCTFCWauto, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCW, py_makeAverageCTFCW, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_mult, mult, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLines, commonLines, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLinesR, commonLinesR, 2, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_fftSlice, py_fftSlice, 3, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setup4Slice, setup4Slice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_insertSlice, insertSlice, 4, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSlice, doneSlice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSliceWF, doneSliceWF, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cutSlice, cutSlice, 2, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_uncutSlice, uncutSlice, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_ctfMap, ctfMap, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dist, dist, 1, 2);

void export_EMData2(python::class_<EMData>& EMData_class, python::class_<PyEMData, python::bases<EMData> >& PyEMData_class)
{

    EMData_class.def("setTAlign", &EMData::setTAlign,
		     EMData_setTAlign("setTAlign(float x, float y, float z=0)"));

    EMData_class.def("setRAlign", (void (EMData::*)(Euler*))&EMData::setRAlign,
		     "setRAlign(Euler angle)");

    EMData_class.def("setRAlign", (void (EMData::*)(float, float, float))&EMData::setRAlign,
		     EMData_setRAlign("setRAlign(float Alt, float Az=0, float Phi=0)"));


    EMData_class.def("NImg", &EMData::NImg,
		     "int NImg() \n  Returns the number images in this image file.");

    EMData_class.def("setNImg", &EMData::setNImg,
		     "setNImg(int n)");

    EMData_class.def("getATime", &EMData::getATime, 
		     "long getATime() \n  Returns access time for the image file.");
    
    EMData_class.def("getImagicHed", &EMData::getImagicHed,
		     python::return_internal_reference<>(),
		     "imagicH getImagicHed()");
    EMData_class.def("setImagicHed", &EMData::setImagicHed, 
		     "setImagicHed(imagicH hed)");
    EMData_class.def("getMRCHed", &EMData::getMRCHed,
		     python::return_internal_reference<>(),
		     "mrcH getMRCHed()");
    EMData_class.def("getSpiHed", &EMData::getSpiHed,
		     python::return_internal_reference<>(),
		     "SPIDERH getSpiHed() \n  Returns the header of a spider image.");
    
    EMData_class.def("Busy", &EMData::Busy, "int Busy() \n  Returns 1 if data is checked out");

    EMData_class.def("waitReady", &EMData::waitReady,
		     "int waitReady(int readonly) \n  Waits for data to become available; Returns 0 if OK; Returns non-zero if any error.");

    EMData_class.def("Wait", &EMData::Wait, "Wait() \n  Waits until the data becomes available.");

    EMData_class.def("swapout", &EMData::swapout, "int swapout() \n  Swaps the data out to a temporary file.");

    EMData_class.def("swapin", &EMData::swapin, "int swapin() \n  Swaps the data in from the swap file.");

    EMData_class.def("zero", &EMData::zero,
		     EMData_zero("zero(int sigma) \n  Sets all the data values to be 0. Non zero sigma will add flatband random noise."));

	EMData_class.def("one", &EMData::one,
		     "one() \n  Sets all the data values to be 1.");
    
    EMData_class.def("ri2ap", &EMData::ri2ap, 
		     "ri2ap() \n  converts real/imaginary to amp/pha (complex only)");
    EMData_class.def("ap2ri", &EMData::ap2ri, 
		     "ap2ri() \n  converts amp/pha to real/imaginary (complex only)");
    PyEMData_class.def("doFFT", &PyEMData::py_doFFT,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData doFFT() \n  Apply fourier transform on the data.");
    
    PyEMData_class.def("doIFT", &PyEMData::py_doIFT,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData doIFT() \n  Apply inverse fourier transform on the data.");
    
    EMData_class.def("gimmeFFT", &EMData::gimmeFFT, 
		     "gimmeFFT() \n  gives the caller ownership of the recently obtained fourier transform, so it won't be freed automatically");

	PyEMData_class.def("doRadon", &PyEMData::py_doRadon,
		       python::return_value_policy<python::manage_new_object>(),
		       " EMData doRadon() \n  Radon transform of image, comes out square");
    PyEMData_class.def("vertACF", &PyEMData::py_vertACF,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData vertACF(int maxdy) \n  vertical autocorrelation calculated in real-space over a range of translations");
    EMData_class.def("doDWT", &EMData::doDWT, 
		     "doDWT(int basis, int level) \n  in place DWT, basis/level defined elsewhere");
    EMData_class.def("doIWT", &EMData::doIWT, 
		     "doIWT(int basis, int level) \n  inverse wavelet x-form");
    EMData_class.def("DWTFilt", &EMData::DWTFilt, 
		     "DWTFilt(int basis, int level, float thresh) \n  in place nonlinear threshold wavelet filter. thresh is with respect to the 'ideal' threshold");

    PyEMData_class.def("convolute", &PyEMData::py_convolute,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData convolute(EMData with)");
    PyEMData_class.def("calcCCF", &PyEMData::py_calcCCF,
		       EMData_py_calcCCF("EMData calcCCF(EMData with, int tozero, EMData filter=None) \n  cross correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcFLCF", &PyEMData::py_calcFLCF,
		       EMData_py_calcFLCF("EMData calcFLCF(EMData with, int r) \n  locally normalized cross correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcCCFX", &PyEMData::py_calcCCFX,
		       EMData_py_calcCCFX("EMData calcCCFX(EMData with, int y0=0, int y1=-1, int nosum=0) \n  calculates sum of x-axis CCFs")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcMCF", &PyEMData::py_calcMCF,
		       EMData_py_calcMCF("EMData calcMCF(EMData with, int tocorner, EMData filter=None) \n  mutual correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("littleBigDot", &PyEMData::py_littleBigDot,
		       EMData_py_littleBigDot("EMData littleBigDot(EMData with, int sigma=0) \n  CCF in real-space, designed for cases where with is small")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("transAlign", &PyEMData::py_transAlign,
		     "tuple transAlign(EMData with, int useparent, int intonly, int maxshift)  \n  translational alignment using CCF");
    EMData_class.def("rotAlign", &EMData::rotAlign, 
		     "float rotAlign(EMData with) \n  rotational alignment using angular correlation");
    EMData_class.def("rotAlignPrecen", &EMData::rotAlignPrecen, 
		     "float rotAlignPrecen(EMData with) \n  rotational alignment assuming centers are correct");
    EMData_class.def("rotAlignCH", &EMData::rotAlignCH, 
		     EMData_rotAlignCH("float rotAlignCH(EMData with, int irad=8, int orad=0) \n  rotational alignment via circular harmonic"));
    EMData_class.def("transAlign3d", &EMData::transAlign3d,
		     EMData_transAlign3d("float transAlign3d(EMData with,int useparent=0,int intonly=0) \n  translational alignment using CCF"));
    PyEMData_class.def("RTFAlignRadon", &PyEMData::py_RTFAlignRadon,
		       EMData_py_RTFAlignRadon("EMData RTFAlignRadon(EMData with,int maxshift=-1,EMData thisf=None,EMData radonwith=None ,EMData radonthis=None,EMData radonthisf=None) \n  rotational, translational and flip alignment with Radon transforms")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTAlignRadon", &PyEMData::py_RTAlignRadon,
		       EMData_py_RTAlignRadon("EMData RTAlignRadon(EMData with,int maxshift=-1,EMData radonwith=None,EMData radonthis=None)")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignSlow", &PyEMData::py_RTFAlignSlow,		     
		       EMData_py_RTFAlignSlow("EMData RTFAlignSlow(EMData with,EMData flip=None,int maxshift=-1)\n  rotational, translational and flip alignment using real-space methods, SLOW")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignSlowest", &PyEMData::py_RTFAlignSlowest,		     
		       EMData_py_RTFAlignSlowest("EMData RTFAlignSlowest(EMData with,EMData flip=None,int maxshift=-1)\n  rotational, translational and flip alignment using exhaustive search. VERY SLOW")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignBest", &PyEMData::py_RTFAlignBest,
		       EMData_py_RTFAlignBest("EMData RTFAlignBest(EMData with=None,EMData flip=None,int maxshift=-1,float *snr) \n  rotational, translational and flip alignment")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RFAlign", &PyEMData::py_RFAlign,
		       EMData_py_RFAlign("EMData RFAlign(EMData with=None,EMData flip=None,int imask=-1) \n  rotational and flip alignment")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTFAlign", &PyEMData::py_RTFAlign,
		       EMData_py_RTFAlign("EMData RTFAlign(EMData with=None,EMData flip=None,int usedot=1,int maxshift=-1) \n  rotational, translational and flip alignment")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTAlignBest", &PyEMData::py_RTAlignBest,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData RTAlignBest(EMData with, int maxshift=0, float *snr)");

    PyEMData_class.def("RTAlign", &PyEMData::py_RTAlign,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData RTAlign(EMData with, int usedot=0, int maxshift=0)");

    EMData_class.def("refineAlign", &EMData::refineAlign, 
		     EMData_refineAlign("refineAlign(EMData with,int mode=1)"));

	PyEMData_class.def("makeRFP", &PyEMData::py_makeRFP,
		       EMData_py_makeRFP("EMData makeRFP(int premasked=0,int unwrap=1)\n  Makes a 'rotational footprint', which is an 'unwound' autocorrelation function. if unwrap is 0 the rfp is not cached. generally the image should be edgenormalized and masked before using this")
		       [python::return_internal_reference<>()]);
    
    PyEMData_class.def("unwrap", &PyEMData::py_unwrap,
		       EMData_py_unwrap("EMData unwrap(int r1=-1,int r2=-1,int xs=-1,int dx=0,int dy=0,int do360=0)\n  maps polar coordinates to cylindrical coordinates")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("calcRCF", &PyEMData::py_calcRCF, 
		     "calcRCF(EMData with, list sum,int NS)");
    
    EMData_class.def("rotateX", &EMData::rotateX, 
		     "rotateX(int dx) \n  This performs a translation of each line along x with wraparound this is equivalent to a rotation when performed on 'unwrapped' maps");
    
    EMData_class.def("rotateAndTranslate", &EMData::rotateAndTranslate, 
		     EMData_rotateAndTranslate("rotateAndTranslate(float scale=1.0,float dxc=0,float dyc=0,float dzc=0,int r=0)"));
    EMData_class.def("rotateAndTranslateFast", &EMData::rotateAndTranslateFast, 
		     EMData_rotateAndTranslateFast("rotateAndTranslateFast(float scale=1.0)\n  rotate and translate using current settings behavior changes if parent is/not set"));

    EMData_class.def("fastTranslate", &EMData::fastTranslate, 
		     EMData_fastTranslate("fastTranslate(int inplace=1)\n  fast integer-only translation"));
    EMData_class.def("rot180", &EMData::rot180, 
		     "rot180()\n  fast rotation by 180 degrees");
    EMData_class.def("cmCenter", &EMData::cmCenter, 
		     EMData_cmCenter("cmCenter(int intonly=1)\n  center at center of mass, ignores old dx,dy"));
    EMData_class.def("applyMask", &EMData::applyMask, 
		     EMData_applyMask("applyMask(int r,int type)\n  applies a circular mask to the data. type=0 is a step cutoff to the mean value type=4 is a step cutoff to zero type=1 fills in with flatband random noise"));
    EMData_class.def("autoMask", &EMData::autoMask, 
		     EMData_autoMask("autoMask(float thresh,float filter=.1) \n  Attempts to automatically mask out the particle, excluding other particles in the box, etc. thresh runs from ~ -2 to 2, negative numbers for dark. protien and positive numbers for light protein (stain) filter is expressed as a fraction of the Fourier radius "));
    EMData_class.def("applyRadFn", &PyEMData::py_applyRadFn, 
		     EMData_applyRadFn("applyRadFn(int n,float x0,float dx, list y,int interp=1)"));
    EMData_class.def("addRadNoise", &PyEMData::py_addRadNoise, 
		     "addRadNoise(int n, float x0, float dx, list y, int interp)");
    EMData_class.def("subtract", &EMData::subtract, 
		     "subtract(EMData data) \n  subtracts 'data' from the current set");
}
