#include "PyEMClasses.h"
#include "Vect.h"
#include "Euler.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>


namespace python = boost::python;

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(print_overloads, print, 0, 2);

void export_Quater()
{
    python::class_<Quater> Quater_class("Quater", "Quater()\nQuater(Euler e)\nQuater(float x, float y, float z, float q)");
    Quater_class.def(python::init<>());
    Quater_class.def(python::init<Euler&>());
    Quater_class.def(python::init<float, float, float, float>());
    Quater_class.def("fromEuler", &Quater::fromEuler, "fromEuler(Euler e)");
    Quater_class.def("toEuler", &Quater::toEuler, "Euler toEuler()");
    Quater_class.def("Print", &Quater::print,
		     print_overloads("print(string id = None, FILE out = stdout)"));
    
    Quater_class.def_readwrite("nx", &Quater::nx);
    Quater_class.def_readwrite("ny", &Quater::ny);
    Quater_class.def_readwrite("nz", &Quater::nz);
    Quater_class.def_readwrite("Q", &Quater::Q);
}
