#include "PyUtil.h"
#include "util.h"
#include <boost/python/detail/api_placeholder.hpp>

void py_save_data(PyList x_list, PyList y_list, int n, const char* fsp)
{
    float* x_array = new float[python::len(x_list)];
    float* y_array = new float[python::len(y_list)];

    list2array(x_list, x_array);
    list2array(y_list, y_array);

    save_data(x_array, y_array, n, fsp);

    array2list(x_array, x_list);
    array2list(x_array, x_list);

    delete [] x_array;
    x_array = 0;
    delete [] y_array;
    y_array = 0;
}

void py_save_data(float x0, float dx, PyList y_list, int n, const char* fsp)
{
    float* y_array = new float[python::len(y_list)];
    list2array(y_list, y_array);

    save_data(x0, dx, y_array, n, fsp);

    array2list(y_array, y_list);
    delete [] y_array;
    y_array = 0;
}


void py_lsqfit(int n, PyList dx_list, PyList dy_list, Float m,
	       Float b, int ign0)
{
    float* dx_array = new float[python::len(dx_list)];
    float* dy_array = new float[python::len(dy_list)];

    list2array(dx_list, dx_array);
    list2array(dy_list, dy_array);

    lsqfit(n, dx_array, dy_array, &m.val, &b.val, ign0);

    array2list(dx_array, dx_list);
    array2list(dy_array, dy_list);

    delete [] dx_array;
    dx_array = 0;
    delete [] dy_array;
    dy_array = 0;
}

float py_interpolate(float xl, int n, PyList x_list, PyList y_list)
{
    float* x_array = new float[python::len(x_list)];
    float* y_array = new float[python::len(y_list)];

    list2array(x_list, x_array);
    list2array(y_list, y_array);

    float result = interpolate(xl, n, x_array, y_array);

    array2list(x_array, x_list);
    array2list(y_array, y_list);
    
    delete [] x_array;
    x_array = 0;
    delete [] y_array;
    y_array = 0;
    
    return result;
}

void py_roteulertb(Float alt, Float az, Float phi, float dx, float dy)
{
    roteulertb(&alt.val, &az.val, &phi.val, dx, dy);
}

void py_appinit(PyList arg_list)
{
    int argc = python::len(arg_list);
    const char** argv = new const char*[argc];
    list2array(arg_list, argv);    
    appinit(argc, const_cast<char**>(argv));
    delete [] argv;
    argv = 0;
}

int py_LOGbegin(PyList arg_list, int ppid)
{
    int argc = python::len(arg_list);
    const char** argv = new const char*[argc];
    list2array(arg_list, argv);    

    int result = LOGbegin(argc, const_cast<char**>(argv), ppid);

    delete [] argv;
    argv = 0;
    return result;
}
