#include "PyVect.h"

static Vect strip_const(const PyVect& pe)
{
    return *(const_cast<PyVect*>(&pe));
}

PyVect::PyVect() : Vect()
{
}

PyVect::PyVect(float xx, float yy, float zz) : Vect(xx, yy, zz)
{
}

PyVect operator * (const PyVect& lhs, float f)
{
    Vect v = strip_const(lhs);
    Vect r = v * f;
    return *(static_cast<PyVect*>(&r));
}

PyVect operator / (const PyVect& lhs, float f)
{
    Vect v = strip_const(lhs);
    Vect r = v / f;
    return *(static_cast<PyVect*>(&r));
}

PyVect operator + (const PyVect& lhs, float f)
{
    Vect v = strip_const(lhs);
    Vect r = v + f;
    return *(static_cast<PyVect*>(&r));
}

PyVect operator - (const PyVect& lhs, float f)
{
    Vect v = strip_const(lhs);
    Vect r = v - f;
    return *(static_cast<PyVect*>(&r));
}

PyVect operator + (const PyVect& lhs, const PyVect& rhs)
{
    Vect v1 = strip_const(lhs);
    Vect v2 = strip_const(rhs);
    Vect r = v1 + v2;
    return *(static_cast<PyVect*>(&r));
}

PyVect operator - (const PyVect& lhs, const PyVect& rhs)
{
    Vect v1 = strip_const(lhs);
    Vect v2 = strip_const(rhs);
    Vect r = v1 - v2;
    return *(static_cast<PyVect*>(&r));
}

int operator == (const PyVect& lhs, const PyVect& rhs)
{
    Vect v1 = strip_const(lhs);
    Vect v2 = strip_const(rhs);
    return (v1 == v2);
}

