#include "PyEMClasses.h"
#include "VolFrag.h"

#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>


namespace python = boost::python;


void export_VolFrag()
{
    python::class_<VolFrag> VolFrag_class("VolFrag", "VolFrag()\n  construct an empty VolFrag instance");
    VolFrag_class.def(python::init<>());

    VolFrag_class.def("setSize", &VolFrag::setSize, 
		      "setSize(int size)\n  sets object size");
    VolFrag_class.def("getSize", &VolFrag::getSize, 
		      "getSize()");
    VolFrag_class.def("setSizeYZ", &VolFrag::setSizeYZ, 
		      "setSizeYZ(int nx, int y, int z)");
    VolFrag_class.def("setSizeI", &VolFrag::setSizeI, 
		      "setSizeI(int nx, int i)");
    VolFrag_class.def("setupIcos", &VolFrag::setupIcos, 
		      "setupIcos()");
    VolFrag_class.def("zero", &VolFrag::zero, 
		      "zero() \n  zero all elements");
    VolFrag_class.def("validXYZ", &VolFrag::validXYZ, 
		      "int validXYZ(int x, int y, int z)");
    VolFrag_class.def("valueAt", &VolFrag::valueAt, 
		      "float valueAt(int x, int y, int z)");
    VolFrag_class.def("setValue", &VolFrag::setValue, 
		      "setValue(int x, int y, int z, float val)");
    VolFrag_class.def("addValue", &VolFrag::addValue, 
		      "addValue(int x, int y, int z, float val)");
    VolFrag_class.def("multValue", &VolFrag::multValue, 
		      "multValue(int x, int y, int z, float val)");
    VolFrag_class.def("addFrag", &VolFrag::addFrag, 
		      "addFrag(VolFrag src)\n  only within the intersection of the 2 frags");
    VolFrag_class.def("writeFile", &VolFrag::writeFile, 
		      "writeFile(filename)\n  return 0 on success not 0 on failure");
    VolFrag_class.def("readFile", &VolFrag::readFile, 
		      "readFile(filename)\n  return 0 on success not 0 on failure");

}
