#include "PyqEM.h"
#include "PyImage.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>


namespace python = boost::python;

#ifdef GUI
void export_ImShape()
{
    python::class_<ImShape> ImShape_class("ImShape", "ImShape class");

    ImShape_class.def(python::init<>());
    ImShape_class.def_readwrite("type", &ImShape::type);
    ImShape_class.def_readwrite("x0", &ImShape::x0);
    ImShape_class.def_readwrite("y0", &ImShape::y0);
    ImShape_class.def_readwrite("x1", &ImShape::x1);
    ImShape_class.def_readwrite("y1", &ImShape::y1);
    ImShape_class.def_readwrite("r", &ImShape::r);
    ImShape_class.def_readwrite("sel0", &ImShape::sel0);
    ImShape_class.def_readwrite("sel1", &ImShape::sel1);
    ImShape_class.def_readwrite("lw", &ImShape::lw);
}
   
void export_BPoint()
{
    python::class_<BPoint> BPoint_class("BPoint", "BPoint class");
    BPoint_class.def(python::init<>());
    BPoint_class.def(python::init<int, int>());
    BPoint_class.def("x", &BPoint::x);
    BPoint_class.def("y", &BPoint::y);
    BPoint_class.def("setX", &BPoint::setX);
    BPoint_class.def("setY", &BPoint::setY);
}

  
void export_qt()
{
    python::class_<PyQApplication> PyQApplication_class("QApplication", "QApplication class");
    PyQApplication_class.def(python::init<int>());
    PyQApplication_class.def("exec_loop", &PyQApplication::exec, "exec");

    python::class_<PyQWidget> PyQWidget_class("QWidget", "QWidget class");
    PyQWidget_class.def(python::init<>());
    PyQWidget_class.def(python::init<PyQWidget*>());
    PyQWidget_class.def(python::init<PyQWidget*, const char*>());
}


void export_Image()
{
    python::class_<Image> Image_class("_Image", "don't use this class. use Image instead.");
    python::class_<PyImage, python::bases<Image> > PyImage_class("QImage", "Image class");

    PyImage_class.def(python::init<PyQWidget*>());
    PyImage_class.def(python::init<PyQWidget*, const char*>());

    Image_class.def("setData", &Image::setData, "setData");
    //Image_class.def(""getData, &Image::getData, "getData");
    //Image_class.def("getQPixmap", &Image::getQPixmap, "getQPixmap");
    Image_class.def("setNullString", &Image::setNullString, "setNullString");
    Image_class.def("addShape", &Image::addShape, "addShape");
    Image_class.def("delShape", &Image::delShape, "delShape");
    Image_class.def("clearShapes", &Image::clearShapes, "clearShapes");
    //Image_class.def("shapeAt", &Image::shapeAt, "shapeAt");
    Image_class.def("nShapes", &Image::nShapes, "nShapes");
    Image_class.def("hilight", &Image::hilight, "hilight");
    Image_class.def("pxtodx", &Image::pxtodx, "pxtodx");
    Image_class.def("pytody", &Image::pytody, "pytody");
    Image_class.def("dxtopx", &Image::dxtopx, "dxtopx");
    Image_class.def("dytopy", &Image::dytopy, "dytopy");
    Image_class.def("getOriginx", &Image::getOriginx, "getOriginx");
    Image_class.def("getOriginy", &Image::getOriginy, "getOriginy");
    Image_class.def("show", &Image::show, "show");
}


void export_ImageMx()
{
    python::class_<ImageMx> ImageMx_class("_ImageMx", "don't use this class. use ImageMx instead.");
    python::class_<PyImageMx, python::bases<ImageMx> > PyImageMx_class("QImageMx", "ImageMx class");

    PyImageMx_class.def(python::init<PyQWidget*>());
    PyImageMx_class.def(python::init<PyQWidget*, const char*>());

    ImageMx_class.def("replaceData", &ImageMx::replaceData, "replaceData");
    ImageMx_class.def("addData", &ImageMx::addData, "addData");
    ImageMx_class.def("removeData", (void (ImageMx::*)(EMData*))
		      &ImageMx::removeData, "removeData");
    
    ImageMx_class.def("removeData", (void (ImageMx::*)(int)) &ImageMx::removeData, "removeData");

    ImageMx_class.def("clearData", &ImageMx::clearData, "clearData");

    ImageMx_class.def("buildMx", &ImageMx::buildMx, "buildMx");
    ImageMx_class.def("makeVisible", &ImageMx::makeVisible, "makeVisible");
    ImageMx_class.def("setAutoDelete", &ImageMx::setAutoDelete, "setAutoDelete");
    ImageMx_class.def("pxtodx", &ImageMx::pxtodx, "pxtodx");
    ImageMx_class.def("pytody", &ImageMx::pytody, "pytody");
}
#endif
