#include "ColorListItem.h"
#include <qpainter.h>

void ColorListItem::paint( QPainter *p )
{
	QFontMetrics fm = p->fontMetrics();
	int yPos;                       // vertical text position

	yPos = fm.ascent() + fm.leading()/2;
	p->drawText(16, yPos, text() );

	// we don't allow white
	if (color.rgb()!=0xffffff) {
		p->setPen(QPen(color,3));
		p->drawLine(2,fm.lineSpacing()/2,14,fm.lineSpacing()/2);
	}
}

int ColorListItem::height(const QListBox *lb ) const
{
	return lb->fontMetrics().lineSpacing() + 1 ;
}

int ColorListItem::width(const QListBox *lb ) const
{
	return lb->fontMetrics().width( text() ) + 20;
}

