#include "Image.h"

MiniImage::MiniImage(QWidget* parent,const char* name):QWidget( parent, name ) {

qp=new QPainter();

//setBackgroundMode(NoBackground);

setCursor(crossCursor);

data=NULL;
nx=ny=0;
}

MiniImage::~MiniImage() {
delete qp;
}

void MiniImage::paintEvent( QPaintEvent *qpe ) {
if (!data || nx<=0 || ny<=0) return;

qp->begin(this);

int x0,y0,dx,dy;
dx=width()/nx;
dy=height()/ny;
x0=(width()%nx)/2;
y0=(height()%ny)/2;

int x,y;
for (y=0; y<ny; y++) {
	for (x=0; x<nx; x++) {
		int c=data[x+y*nx];
		qp->fillRect(x0+x*dx,y0+y*dy,dx,dy,QColor(c,c,c));		
	}
}
qp->setPen(QColor(yellow));
qp->drawRect(x0+(nx/2)*dx,y0+(ny/2)*dy,dx,dy);
qp->end();
}

void MiniImage::setData(unsigned char *Data,int Nx,int Ny) {
nx=Nx;
ny=Ny;
data=(unsigned char*)realloc(data,nx*ny);
memcpy(data,Data,nx*ny);

update();
}
