// mkalitst.C Copyright 1999 Steve Ludtke
// This program makes a set of alignment test images
// for testing 2d r/t alignment in the presence of noise

#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "List.h"

#include "EMData.h"

struct RTP { float dx,dy,da; };

int nrtp=5;
RTP rtp[] = { 0,0,10.0, 3.0,2.0,33.0, -1.0,-1.0,69.0, 10.0,3.0,0, -7.0,0,17.0 };

main(int argc, char** argv)
{
int i,j;
float filtr;
EMData *in,*tmp,*tmp2;
EMData *out;
char s[80];
float *fn;

if (argc<3) { 
	printf("Takes an input image an makes a set of output images with noise\nand specific r/t adjustments for testing 2d alignment\n");
	exit(0); 
}

in=new EMData();
in->readImage(argv[1],0);
in->normalize();
out=in->copy();
fn=(float *)malloc((in->ySize()/2+2)*sizeof(float));
for (i=0; i<in->ySize()/2+1; i++) fn[i]=.001*exp(-(float)i*2.0/(float)in->ySize());

for (j=0; j<4; j++) {
	for (i=0; i<nrtp; i++) {
		out->setRAlign(rtp[i].da*PI/180.0);
		out->setTAlign(rtp[i].dx,rtp[i].dy);
		out->rotateAndTranslate();

		tmp=out->doFFT();
		tmp->addRadNoise(in->ySize()/2,1.0,1.0,fn,1);
		tmp2=tmp->doIFT();
		tmp->gimmeFFT();

		sprintf(s,"%1.2f %1.2f %1.2f",rtp[i].dx,rtp[i].dy,rtp[i].da);
		tmp2->setName(s);
		tmp2->writeIMAGIC(argv[2],-1);

		delete tmp2;
	}
	for (i=0; i<in->ySize()/2+1; i++) fn[i]*=5.0;
}

}

