// stats.C Copyright 1999 Steve Ludtke

#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "List.h"

#include "EMData.h"

main(int argc, char** argv)
{
int i,j,nic,n,cls,bi,change=1,f4count=0;
int showp=0,split=0;
EMData *tmp,*tmp2;
List *data,*centers,*newcenters;
int *asgn;
float dot,bdot;
char s[80];

if (argc<3) { 
	printf("Usage: stats <input images> <classes> [showptcl] [split]\n");
	exit(0); 
}


for (i=3; i<argc; i++) {	
	if (strncmp(argv[i],"showptcl",8)==0) showp=1;
	else if (strncmp(argv[i],"split",5)==0) split=1;
	else { printf("Unknown option %s\n",argv[i]); exit(1); }
}


data=readImages(argv[1],-1,-1);
n=data->count();
asgn=(int *)calloc(n*sizeof(int),1);
cls=atoi(argv[2]);

printf("%d images\n",data->count());

// normalize images
for (i=0; i<n; i++) { 
	tmp=(EMData *)data->objectAt(i);
	tmp->normalize();
}

// pick some starting centers
centers=new List;
newcenters=new List;
for (i=0; i<cls; i++) {
	tmp=(EMData *)data->objectAt(i*n/cls);
	newcenters->addObject(tmp->copy());
}

while (change) {
	change=0;
	
	for (i=0; i<centers->count(); i++) delete (EMData *)centers->objectAt(i);
	delete centers;
	centers=newcenters;
	newcenters=new List;

// set up List for new averages
	tmp=(EMData *)data->objectAt(0);
	tmp=tmp->copy();
	tmp->zero();
	for (i=0; i<cls; i++) {
		newcenters->addObject(tmp->copy(0,0));
	}
	delete tmp;

// classify
	printf("----------\n");
	for (i=0; i<n; i++) {
		tmp=(EMData *)data->objectAt(i);
		bdot=-1.0e15;
		bi=0;
		for (j=0; j<cls; j++) {
			tmp2=(EMData *)centers->objectAt(j);
			dot=tmp->dot(tmp2);
			if (dot>bdot) { bdot=dot; bi=j; }
		}
		if (bi!=asgn[i]) { 
			printf("%d. %d -> %d\n",i,asgn[i],bi);
			change=1; 
			asgn[i]=bi; 
		}
		tmp2=(EMData *)newcenters->objectAt(bi);
		tmp2->add(tmp);
	}

// renormalize
	for (i=0; i<cls; i++) {
		tmp=(EMData *)newcenters->objectAt(i);
		tmp->normalize();
	}	
}

if (split) {
	for (i=0; i<n; i++) {
		tmp=(EMData *)data->objectAt(i);
		sprintf(s,"split%02d.hed",asgn[i]);
		tmp->writeIMAGIC(s,-1);
	}
}

if (showp) {
	FILE *out=fopen("stats.out","wb");
	for (i=0; i<n; i+=4) {
		if (out) fprintf(out,"%5d. %2d %2d %2d %2d\n",i/4,asgn[i],asgn[i+1],asgn[i+2],asgn[i+3]);
		printf("%5d. %2d %2d %2d %2d",i/4,asgn[i],asgn[i+1],asgn[i+2],asgn[i+3]);
		if (asgn[i]==asgn[i+1] && asgn[i]==asgn[i+2] && asgn[i]==asgn[i+3]) {
			f4count++;
			printf("  <----\n");
		}
		else printf("\n");
	}
	fclose(out);
}
printf("%d/%d are 4-fold identical\n",f4count,n/4);

for (i=0; i<cls; i++) {
	nic=0;
	for (j=0; j<n; j++) if (asgn[j]==i) nic++;
	tmp=(EMData *)newcenters->objectAt(i);
	tmp->setNImg(nic);
	tmp->writeIMAGIC("averages.hed",-1);
}	

}
