// quarter.C Copyright 1999 Steve Ludtke
// This is a program to take top views of a homotetrameric molecule
// and align them to a reference, then split each into 4 'identical'
// pieces for statistical analysis

#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "List.h"

#include "EMData.h"

main(int argc, char** argv)
{
int i,j,n,ny,ni;
EMData *im,*tmp,*tmpc,*big;
float *d;

if (argc<3) { 
	printf("Unquarter top views of homotetramers\nUsage: quarter <quarters> <output>\n");
	exit(0); 
}
/*
for (i=3; i<argc; i++) {	
	if (strncmp(argv[i],"mask=",5)==0) mask=atoi(&argv[i][5]);
	else { printf("Unknown option %s\n",argv[i]); exit(1); }
}
*/

n=fileCount(argv[1]);
im=new EMData;
im->readImage(argv[1],i);
ny=im->ySize()*2;
big=new EMData;
big->setSize(ny,ny,1);

for (i=0; i<n; i++) {
//	if (i%10==0) { printf(" %d\r",i); fflush(stdout); }
	big->zero();
	im->readImage(argv[1],i);
	ni=im->NImg();
	tmp=im->clip(-1,0,ny,ny);
	tmpc=tmp->copy(0,0);
	for (j=0; j<4; j++) {
		tmpc->setRAlign(j*PI/2,0,0);
		tmpc->setTAlign(0,0,0);
		tmpc->rotateAndTranslate();
		big->add(tmpc);
	}
	d=big->getData();
	j=ny/2*ny+ny/2;
	d[j]=(d[j-1]+d[j+1]+d[j-ny]+d[j+ny])/4;	//acutally all 4 should be the same
	big->doneData();
	big->applyMask(0,ny/2-2);
	big->normalize();
	big->setNImg(ni);
	big->writeIMAGIC(argv[2],-1);
	delete tmp;
	delete tmpc;
}

}

