#include <stdio.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <math.h>

//#define NITER 8

main(int argc, char *argv[]) {
EMData *im5,*im2,*im3,*f5,*f3,*f2,*c5,*c3,*c2,*vol,*vol2;
int nx,ny,imask=-1;
Euler *a,e;
float phi[3],pr,bpr,bphi,bnorm,*d,val[181];
int mode=2,nk,n,i,j,k;
char *sym="icos";
char s[1024];
char *file;

if (argc<3) { printf("starticos <centered particles> <# to keep> [mode=<mode>] [imask=<rad>]\n"); exit(0); }

nk=atoi(argv[2]);
if (nk<1) { printf("# to keep must be >0\n"); exit(1); }

n=fileCount(argv[1]);
if (n<3) { printf("Input file too small ?!?!\n"); exit(1); }
if (n/3<nk) { printf("<# to keep> should be less than 1/3 number of particles\n"); exit(1); }

for (i=3; i<argc; i++) {	
	if (strncmp(argv[i],"out=",4)==0) file=&argv[i][4];
	else if (strncmp(argv[i],"mode=",5)==0) mode=atoi(&argv[i][5]);
	else if (strncmp(argv[i],"imask=",6)==0) imask=atoi(&argv[i][6]);
	else { printf("Unknown argument '%s'\n",argv[i]); exit(1); }
}

/*
system("rm -f cls*hed cls*img sym.hed sym.img");

// for each symmetry axis (5,3,2 fold), find the best representative
// particles and store them for alignment
sprintf(s,"symsort %s sym=c5 imask=%d",argv[1],imask);
system(s);
sprintf(s,"proc2d %s cls000.hed last=%d",argv[1],nk-1);
system(s);

sprintf(s,"symsort %s sym=c3 imask=%d",argv[1],imask);
system(s);
sprintf(s,"proc2d %s cls001.hed last=%d",argv[1],nk-1);
system(s);

sprintf(s,"symsort %s sym=c2 imask=%d",argv[1],imask);
system(s);
sprintf(s,"proc2d %s cls002.hed last=%d",argv[1],nk-1);
system(s);

// Now generate classums for each of the symmetric axes
sprintf(s,"classalignall median dot keep=.9 10 precen imask=%d",imask);
system(s);

// Now we actually enforce the symmetry. This could be considered
// cheating a little, but is fine for preliminary images
system("proc2d classes.hed sym.hed sym=c5 first=0 last=0");
system("proc2d classes.hed sym.hed sym=c3 first=1 last=1");
system("proc2d classes.hed sym.hed sym=c2 first=2 last=2");
*/

// now read in the final symmetric classums from above
im5=new EMData;
if (im5->readImage("sym.hed",0)) { printf("classes.hed not created, must have been an error.\n"); exit(1); }
im5->toCorner();
 f5=im5->doFFT();
im5->gimmeFFT();
 f5->setRAlign(0,0,0);
 f5->setNImg(1);
 f5->getEuler()->setSym(sym);

im3=new EMData;
if (im3->readImage("sym.hed",1)) { printf("classes.hed too short, must have been an error.\n"); exit(1); }
im3->toCorner();
 f3=im3->doFFT();
im3->gimmeFFT();
 f3->setRAlign(42.29*PI/180.0,0,0);	// ???
 f3->setNImg(1);
 f3->getEuler()->setSym(sym);

im2=new EMData;
if (im2->readImage("sym.hed",2)) { printf("classes.hed too short, must have been an error.\n"); exit(1); }
im2->toCorner();
 f2=im2->doFFT();
im2->gimmeFFT();
 f2->setRAlign(31.7175*PI/180.0,36.0*PI/180.0,0); // ??? az/phi swapped?
 f2->setNImg(1);
 f2->getEuler()->setSym(sym);

nx=im5->xSize();
ny=im5->ySize();

vol=new EMData;
vol->setup4IS(ny);
vol2=new EMData;
vol2->setup4IS(ny);

/*
c52=new EMData;
c53=new EMData;

c52->commonLines(f5,f2,0);
c53->commonLines(f5,f3,0);
*/

printf("Calculate common lines\n");
c5=new EMData;
c3=new EMData;
c2=new EMData;

c5->commonLines(f5,f5,1);
c3->commonLines(f3,f3,1);
c2->commonLines(f2,f2,1);

printf("Searching\n");
// 5 fold
if (c5->ySize()!=360) exit(1);

d=c5->getDataRO();
for (i=0; i<72; i++) {
	val[i]=0;
	for (j=0,k=i; j<180; j++,k--) {
		if (k<0) k+=360;
		val[i]+=450-(d[i+k*360]+d[i+72+k*360]+d[i+144+k*360]+d[i+216+k*360]+d[i+288+k*360]);
	}
}
c5->doneData();

phi[0]=0;
pr=0;
for (i=0; i<72; i++) {
	if (val[i]>pr) { pr=val[i]; phi[0]=i; }
}
printf("5 fold at %f\n",phi[0]);

// 3 fold
d=c3->getDataRO();
for (i=0; i<120; i++) {
	val[i]=0;
	for (j=0,k=i; j<180; j++,k++,k=k%360) {
		val[i]+=d[i+k*360]+d[i+120+k*360]+d[i+240+k*360];
	}
}
c3->doneData();

phi[1]=0;
pr=0;
for (i=0; i<120; i++) {
	if (val[i]>pr) { pr=val[i]; phi[1]=i; }
}
printf("3 fold at %f\n",phi[1]);

// 2 fold
d=c2->getDataRO();
for (i=0; i<180; i++) {
	val[i]=0;
	for (j=0,k=i; j<180; j++,k++,k=k%360) {
		val[i]+=d[i+j*360]+d[i+180+j*360];
	}
}
c2->doneData();

phi[2]=0;
pr=0;
for (i=0; i<180; i++) {
	if (val[i]>pr) { pr=val[i]; phi[2]=i; }
}
printf("2 fold at %f\n",phi[2]);

// OK now build a model

vol->setup4IS(ny);

/*
// 3 fold again
bphi=0;
bpr=1.0e5;

for (phi=30.0*PI/180.0; phi<150.0*PI/180.0; phi+=.25*PI/180.0) {
	vol2->normSlice(f3,f3->alt(),f3->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f3->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f3,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 3f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

// 2 fold
bphi=0;
bpr=1.0e5;

for (phi=45.0*PI/180.0; phi<235.0*PI/180.0; phi+=.25*PI/180.0) {
	vol2->normSlice(f2,f2->alt(),f2->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f2->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f2,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 2f pr @ %f (%f)\n",bphi*180.0/PI,bpr);


// 5 fold again
a=f5->getEuler();
a->setAngle(a->alt(),a->az(),-phi[0]);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f5,e.alt(),e.az(),e.phi(),mode,1); 			
}
*/

/*
// 5 fold
bphi=0;
bpr=1.0e5;
//for (phi=36.0*PI/180.0; phi<108.0*PI/180.0; phi+=1.0*PI/180.0) {
for (phi=0.0*PI/180.0; phi<216.0*PI/180.0; phi+=2.0*PI/180.0) {
	a=f5->getEuler();
	a->setAngle(0,phi,0);
	for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
		vol->insertSlice(f5,e.alt(),e.az(),e.phi(),mode,1); 			
	}
	vol->normSlice(f5,0,phi,0,&pr);
printf("%f\t%f\n",phi*180.0/PI,pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }

	vol->setup4IS(ny);	
}
printf("Best 5f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

vol->setup4IS(ny);
a=f5->getEuler();
a->setAngle(0,0,bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f5,e.alt(),e.az(),e.phi(),mode,1); 			
}

//////////////

// 3 fold
bphi=0;
bpr=1.0e5;

for (phi=30.0*PI/180.0; phi<150.0*PI/180.0; phi+=.5*PI/180.0) {
	vol->normSlice(f3,f3->alt(),f3->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f3->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol2->insertSlice(f3,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 3f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

// 2 fold
bphi=0;
bpr=1.0e5;

for (phi=45.0*PI/180.0; phi<235.0*PI/180.0; phi+=.5*PI/180.0) {
	vol->normSlice(f2,f2->alt(),f2->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f2->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol2->insertSlice(f2,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 2f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

// 5 fold again
bphi=0;
bpr=1.0e5;

for (phi=36.0*PI/180.0; phi<108.0*PI/180.0; phi+=.5*PI/180.0) {
	vol->normSlice(f5,f5->alt(),f5->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f5->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol2->insertSlice(f5,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 5f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

///////////////////////

vol->setup4IS(ny);

// 3 fold again
bphi=0;
bpr=1.0e5;

for (phi=30.0*PI/180.0; phi<150.0*PI/180.0; phi+=.25*PI/180.0) {
	vol2->normSlice(f3,f3->alt(),f3->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f3->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f3,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 3f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

// 2 fold
bphi=0;
bpr=1.0e5;

for (phi=45.0*PI/180.0; phi<235.0*PI/180.0; phi+=.25*PI/180.0) {
	vol2->normSlice(f2,f2->alt(),f2->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f2->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f2,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 2f pr @ %f (%f)\n",bphi*180.0/PI,bpr);

// 5 fold again
bphi=0;
bpr=1.0e5;

for (phi=36.0*PI/180.0; phi<108.0*PI/180.0; phi+=.25*PI/180.0) {
	vol2->normSlice(f5,f5->alt(),f5->az(),phi,&pr);
	if (pr<bpr) { bpr=pr; bphi=phi; }
}

a=f5->getEuler();
a->setAngle(a->alt(),a->az(),bphi);
for (e=a->FirstSym(); e.valid(); e=a->NextSym()) {
	vol->insertSlice(f5,e.alt(),e.az(),e.phi(),mode,1); 			
}
printf("Best 5f pr @ %f (%f)\n",bphi*180.0/PI,bpr);
*/

vol->doneSlice();
vol2=vol->doIFT();
vol2->toCorner();
vol2->applyMask(-1,100+mode);
vol2->applyMask(-1,0);
vol2->writeMRC("threed.0a.mrc");

}
