IsoPlot::IsoPlot( QWidget *parent, const char *name ):QGLWidget(parent,name) {
needupd=0;
}

IsoPlot::~IsoPlot() {
cdata=vertex=NULL;
};

void IsoPlot::setThr(float val) {
thr=(int)floor(255.0*(val-min)/(max-min));
needupd=1;
}

// we make a copy of the cdata after doing a float->char translation
void IsoPlot::setcdata(unsigned char *d,int x,int y,int z) {
nx=x;
ny=y;
nz=z;

cdata=(unsigned char *)realloc(cdata,nx*ny*nz);

max=min=d[0];
for (i=1; i<nx*ny*nz; i++) {
	if (d[i]>max) max=d[i];
	if (d[i]<min) min=d[i];
}

for (i=0; i<nx*ny*nz; i++) {
	cdata[i]=floor(255.9*(d[i]-min)/(max-min));
}

needupd=1;
}

int VTX[12][0] = { 0,1, 2,3, 4,5, 6,7, 0,2, 1,3, 4,6, 5,7, 0,4, 1,5, 2,6, 3,7 };

// This renders the isosurface into the specified display list
void IsoPlot::render(int list,float *mx) {
int nv=0;
int x,y,z,i,j,k;
int d0,d1;
unsigned char *v2;

vertex=(char *)realloc(vertex,nx*ny*nz*3);

for (i=0; i<12; i++) p[i]=-1.0;

// search for all isosurface vertices
// 3 maps represent lines connecting 3d mesh in x, y and z
// 0 represents no vertex, 1-255 represents relative vertex
// position between points
v2=vertex;
for (z=0; z<nz; z++) {
	for (y=0; y<ny; y++) {
		i=y*nx+z*nx*ny;
		d1=cdata[i];
		for (x=0; x<nx-1; x++) {
			i++;
			d0=d1;
			d1=cdata[i];
			if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
				v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
			}
			else v2[i]=0;

		}
	}
}

v2=vertex+nx*ny*nz;
for (z=0; z<nz; z++) {
	for (x=0; x<nx; x++) {
		i=x+z*nx*ny;
		d1=cdata[i];
		for (y=0; y<ny-1; y++) {
			i+=nx;
			d0=d1;
			d1=cdata[i];
			if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
				v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
			}
			else v2[i]=0;

		}
	}
}

v2=vertex+2*nx*ny*nz;
for (y=0; y<ny; y++) {
	for (x=0; x<nx; x++) {
		i=x+y*nx;
		d1=cdata[i];
		for (z=0; z<nz-1; z++) {
			i+=nx*ny;
			d0=d1;
			d1=cdata[i];
			if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
				v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
			}
			else v2[i]=0;

		}
	}
}

// now draw the surface into a compiled GL list
glNewList( list,GL_COMPILE );

switch (mode) {
case MODE_POINT:
	glBegin(GL_POINTS);
	v2=vertex;
	for (z=0; z<nz; z++) {
		for (y=0; y<ny; y++) {
			i=y*nx+z*nx*ny;
			d1=cdata[i];
			for (x=0; x<nx-1; x++) {
				i++;
				d0=d1;
				d1=cdata[i];
				if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
					v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
				}
				else v2[i]=0;
			}
		}
	}

	v2=vertex+nx*ny*nz;
	for (z=0; z<nz; z++) {
		for (x=0; x<nx; x++) {
			i=x+z*nx*ny;
			d1=cdata[i];
			for (y=0; y<ny-1; y++) {
				i+=nx;
				d0=d1;
				d1=cdata[i];
				if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
					v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
				}
				else v2[i]=0;	

			}
		}
	}

	v2=vertex+2*nx*ny*nz;
	for (y=0; y<ny; y++) {
		for (x=0; x<nx; x++) {
			i=x+y*nx;
			d1=cdata[i];
			for (z=0; z<nz-1; z++) {
				i+=nx*ny;
				d0=d1;
				d1=cdata[i];
				if ((d0>=thr&&d1<thr) || (d0<thr&&d1>=thr)) {
					v2[i]=(unsigned char)(256*(thr-d0)/(d1-d0));
				}
				else v2[i]=0;

			}
		}
	}

	break;
case MODE_MESH:
	break;
case MODE_SURF:
	break;
}

glEndList();
}
