// eulerrefine.C 02/11/03  Steve Ludtke

//N eulerclassrefine
//F This program will try to refine the Euler angles for a set of class-averages using the concept of common-lines
//T LT
//1
//P <classfile>	File containing class-averages to refine
//D This program will attempt to refine the Euler angles for a set of class-averages. It relies on
//E the images having relatively low noise levels. It also relies on the presence of moderately accurate
//E Euler angles already being present in the image headers. It will strive to locally adjust Eulers for
//E more self-consistency.

#include <cstdio>
#include <cmath>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {

appinit(argc,argv);

/*
for (i=3; i<argc; i++) {
	if (strncmp(argv[i],"clip=",5)==0) {
		if( sscanf(&argv[i][5],"%d,%d,%d,%d,%d,%d",&nx,&ny,&nz,&xc,&yc,&zc) != 6)
			sscanf(&argv[i][5],"%d , %d , %d",&nx,&ny,&nz);
	}
	else if (strncmp(argv[i],"scale=",6)==0) scale=atof(&argv[i][6]);
	else if (strncmp(argv[i],"apix=",5)==0) apix=atof(&argv[i][5]);
*/

data=readImages(argv[1],0,-1);
if (data->count()<3) {
	printf("Need at least 3 images!\n");
	exit(1);
}
int ntp = 0;
EMData *d,*d2;
for (i=0; i<data->count(); i++) {
	d=(EMData *)data->objectAt(i);
	if (d->NImg()>0) ntp++;
}

printf("%d class averages to process\n",ntp);

// main loop for adjustments
// we loop over
List toproc;
for (i=data->count()-1; i>=0 i--) {
	d=(EMData *)data->objectAt(i);
	if (toproc->count()==0) {
		if (d->NImg()<0) continue;
		toproc.addObject(d);
	}
	
	d2=(EMData *)toproc->objectAt(0);
	if (d->Alt()!=d2->Alt()) {
		// we only do processing if there are 4 or more images at the same altitude
		if (toproc.count()<4) {
			printf("%d particles at alt=%f, skipping\n",toproc.count(),d->Alt());
			toproc.empty();
		}
		// ok, this is the actual processing for a given altitude
		else {

		}
	}

	toproc.addObject(d);
}