// by Wen Jiang, June 2000
// use OpenInventor library, so it is only working on SGI at this moment
//
//N iv2cosec
//F This program converts helices in Open Inventor format to COSEC secondary structure elements file format
//T X
//1
//P <input IV file>	The Open Inventor format file
//P <output COSEC file>	The output COSEC format file
//P	[verbose]	will output some intermediate information
//U	iv2cosec in.iv out.cosec verbose
//D	This program uses Open Inventor library, so it is only working on SGI at this moment.
//D	This program works correctly only for the special Open Inventor file containing only cylinders (helices).
//D	Visit web page <a href="http://ncmi.bcm.tmc.edu/~wjiang/hhfh">Helixhunter and Foldhunter</a> for 
//E	more information.

#include <iostream>
#include "Cylinder.h"

void	main(int argc, char **argv)
{

	if (argc < 3) {
		cerr << argv[0] << ":\tconvert Open Inventor file describing the helices into COSEC Secondary Structure Elements file\n";
		cerr << "Usage:\t" << argv[0] << " <iv file> <cosec file> [verbose]\n";
		exit(1);
	}

	bool verbose=false, isgood;
	for (int i = 3; i < argc; i++) {
		if (strncmp(argv[i], "verbose", 7) == 0)
			verbose = true;
		else { 
			cerr << argv[0] << ":\tunknown parameter '" << argv[i] << "'\n"; 
			exit(2); 
		}
	}

	Cylinders cyls;
	if (!strcmp(&argv[1][strlen(argv[1])-4],".wrl") || !strcmp(&argv[1][strlen(argv[1])-3],".iv") )
		isgood=cyls.ReadInventor(argv[1]);
	else 
		isgood=cyls.ReadListfile(argv[1]);

	if(isgood) {
		cyls.WriteCosec(argv[2],argv[0]);
		if(verbose)
			cout << cyls.size() <<" helices wirtten into COSEC file \""<<argv[2]<<"\"\n";
	} 
}


