// mx2img.C  2001 Steven Ludtke
// Copyright 2001 Baylor College of Medicine

//N mx2img
//F This program converts a distance matrix to an MRC image
//T LM
//1
//P <matrix file>	Input matrix file
//P <MRC file>	Output MRC image
//U mx2img matrix.dat matrix.mrc
//D This program will convert the matrix file created by the matrix
//E option of classesbymra into a standard MRC image. This is
//E generally used in conjunction with <a href=glmatrix.html>glmatrix</a> or
//E <a href=matrixembed.html>matrixembed</a>.

#include <cstdio>
#include <cmath>
#include "EMData.h"
#include "util.h"

int main(int argc,char *argv[]) {

appinit(argc,argv);

int nr,ns,i,j;
int swap=0;
FILE *in = fopen(argv[1],"rb");
if (!in) error(ERR_EXIT,"Cannot read matrix file");
fread(&nr,sizeof(int),1,in);
if (nr>10000||nr<1) { swap=1; swapint((char*)&nr,1); }
fread(&ns,sizeof(int),1,in);
if (ns>10000||ns<1) { swap=1; swapint((char*)&ns,1); }
printf("Matrix %d x %d\n",nr,ns);

// read the matrix file
EMData d;

d.setSize(nr,ns,1);
d.zero();
float *dat = d.getData();
for (i=0; i<ns; i++) {
	fread(&j,sizeof(int),1,in);
	if (swap) swapint((char *)&j,1);
	fread(dat+nr*j,sizeof(float),nr,in);
}
fclose(in);
if (swap) swapint((char *)dat,nr*ns);
d.doneData();

d.writeMRC(argv[2]);
exit(0);
}
