#ifndef IMAGEH
#define IMAGEH

#include <cstdio>
#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qfont.h> 
#include <qfontmet.h> 
#include <qdict.h>
#include <qintdict.h>
#include <qlist.h>
#include "EMData.h"

class Image:public QWidget {
    Q_OBJECT

QPainter *qp;
QPaintDevice *qpd;
QPixmap *qpm;

EMData *data;

int needupd;
int mode;
float cont,brite;

public:
			
Image( QWidget *parent=0, const char *name=0 );
~Image();

void setData(EMData *d);
EMData *getData();

virtual void paintEvent( QPaintEvent *qp );
virtual void mousePressEvent(QMouseEvent *);
virtual void mouseReleaseEvent(QMouseEvent *);
virtual void mouseDoubleClickEvent(QMouseEvent *e);
virtual void mouseMoveEvent(QMouseEvent *);
virtual void mouseEnter(int);
virtual void mouseLeave(int);
virtual void keyPressEvent(QKeyEvent *);
virtual void keyReleaseEvent(QKeyEvent *);
virtual void resizeEvent ( QResizeEvent * );
virtual void print(QPaintDevice *dev);

signals:
	void	changed();
	void	sChange(float r,float r2,float ang);
	void	newBox(QRect *r);

public slots:
	void	imageChanged();
	void	setMode(int val);
	void	setCont(float val);
	void	setBrite(float val);
};

inline EMData *Image::getData() { return data; }
inline void Image::setMode(int val) { mode=val; needupd=1; update(); }
inline void Image::setCont(float val) { cont=val; needupd=1; update(); }
inline void Image::setBrite(float val) { brite=val; needupd=1; update(); }

#endif
